<?
/* $Id: lib.inc.php,v 3.6 2003/04/03 08:02:22 bzizou Exp $

This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been writen by Julien Dumont and Bruno Bzeznik - copyright (C) 2002
Ce script  t crit par Julien Dumont and Bruno Bzeznik - copyright (C) - 2002

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

/* loading libs */
require("../inc/import.inc.php");
require("../../slis.conf.php");
require("../inc/log.inc.php");
require("../inc/lang.inc.php");
require("../inc/themes.inc.php"); // output themes.
require("../inc/md5crypt.php");

function is_groups_delete($db,$gid,$uid)  // check if affiliation groupeid - userid  is delete. return 1 if it is or 0 if it isn't
{
    $query = "select delete from \"groups\" where userid='$uid' and classeid='$gid' ;";
    $result = pg_exec($db,$query);
    $row = pg_fetch_row($result,0);
    $valtmp = $row[0];
    if($valtmp == "t")
    {
        $val ="1";
    }
    else
    {
        $val = "0";
    }
    unset($valtmp);
    return($val);
}

function remake_passwd($db,$userid)   // return 0 if failed or 1 if ok
{
    $npass = makepass();
    /* add encrypt passwd */
    $passmd5 = makemd5($npass);
    $passcrypt = makecrypt($npass);
    $querypass = "update \"password\" set md5='$passmd5',crypt='$passcrypt' where id='$userid';";
    $v_querypass = pg_exec($db,$querypass);
    $querypass2 = "update \"users\" set passwd='$npass' where id='$userid';";
    $v_querypass2 = pg_exec($db,$querypass2);
    if( ($v_querypass) && ($v_querypass2) )
    {
        $val = 1;
    }
    else
    {
        $val = 0;
    }
    return($val);
}

function make_alias($Nom,$Prenom) // return first user alias
{
    $prenom = OterAccents($Prenom);
    $nom = OterAccents($Nom);
    $prenom = OterBadcaract($Prenom);
    $nom = OterBadcaract($Nom);
    return("$prenom.$nom");
}

function is_alias_delete($db,$common_id,$alias)  // check if alias is delete. return 1 if it is or 0 if it isn't
{
    $query = "select delete from alias where id='$common_id' and alias='$alias' ;";
    $result = pg_exec($db,$query);
    $row = pg_fetch_row($result,0);
    $valtmp = $row[0];
    if($valtmp == "t")
    {
        $val ="1";
    }
    else
    {
        $val = "0";
    }
    unset($valtmp);
    return($val);
}

function is_common_delete($db,$common_id)  // check if common_id object is delete. return 1 if it is or 0 if it isn't
{
    $type = get_idtype($db,$common_id);
    if($type == "classe")
    {
        $query = "select delete from classes where id='$common_id' ;";
        $result = pg_exec($db,$query);
        $row = pg_fetch_row($result,0);
        $valtmp = $row[0];
        if($valtmp == "t")
        {
            $val ="1";
        }
        else
        {
            $val = "0";
        }
    }
    elseif($type == "users")
    {
        $query = "select delete from users where id='$common_id' ;";
        $result = pg_exec($db,$query);
        $row = pg_fetch_row($result,0);
        $valtmp = $row[0];
        if($valtmp == "t")
        {
            $val ="1";
        }
        else
        {
            $val = "0";
        }
    }
    unset($valtmp);
    return($val);
}

function errormsg($msg)    // return a formated error msg
{
    return("<P><center><font face=\"Helvetica,Arial\" color=\"#FF0000\"><H3>$msg</H3></font></center>");
}

function CheckName($chaine) // return "ok" ou "error msg" for valid a name.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    $check = "ok"; // valid by default.
    $long = strlen($chaine);
    if($long > 8) // more than 8 caracters.
    {
        $check = "<br>".errormsg($lang_Name_more_than_8)." ".center("$lang_Group <b>$chaine</b> $lang_nocreate<br><br>&nbsp;");
        slislog(warning,"name are more 8 caracters in function CheckName of inc/lib.inc.php");
    }
    if( preg_match("/\W/",$chaine) )
    {
        if(!(preg_match("/_/",$chaine) || preg_match("/-/",$chaine)))
        {
            $check = "ok";
        }
        if( ($check == "ok") && ( (!(preg_match("/\'/",$chaine))) || (!(preg_match("/\"/",$chaine))) ) )
        {
            $check == "ok";
        }
        else
        {
            $check = "bad";
        }
        if(!($check == "ok"))
        {
            $check = errormsg($lang_Name_bad_caracters)." ".center("$lang_Group <b>$chaine</b> $lang_nocreate<br><br>&nbsp;");
            slislog(warning,"name are bad caracters - or _ in function CheckName of inc/lib.inc.php");
        }
    }
    return($check);
}

function OterHTML_PHP($chaine) // return string without html or php
{
    $val = strip_tags($chaine);
    return($val);
}

function OterAccents($chaine) // return string without "accents"
{
   return( strtr( $chaine,"","AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn" ) );
}

function OterBadcaract($chaine) // return string without "bad carcter"
{
   while(preg_match("/\'/",$chaine))
   {
        $chaine = preg_replace("/\'/","",$chaine);
   }
   while(preg_match("/\"/",$chaine))
   {
        $chaine = preg_replace("/\"/","",$chaine);
   }
   return $chaine;
}

function OterSpace($chaine) // return string without "space" or "\n";
{
    return( strtr($chaine," ","") );
}

function makemd5($chaine) // $chaine to md5
{
    $pass = md5crypt($chaine,"yy");
    return($pass);
}
function makecrypt($chaine) // $chaine to crypt
{
   $chars = "abcdefghijkmnopqrstuvwxyz23456789"; // autorize char
   srand((double)microtime()*1000000);
   for($i=0; $i<2; $i++) // password of 8 caracters
   {
      $salt .= $chars[rand()%strlen($chars)];
   }
   return(  crypt($chaine,$salt) );
}

function makepass() // make password
{
   $chaine = "abcdefghijkmnopqrstuvwxyz23456789"; //caractres possibles
   srand((double)microtime()*1000000);
   for($i=0; $i<8; $i++) // password of 8 caracters
   {
      $pass .= $chaine[rand()%strlen($chaine)];
   }
   return($pass);
}

function mklogin($Nom,$Prenom,$db) // make login in fonction of name and surename
{
   // without "accents"
   $Nom = OterAccents($Nom);
   $Prenom = OterAccents($Prenom);

   // without "bad caract"
   $Nom = OterBadcaract($Nom);
   $Prenom = OterBadcaract($Prenom);

   // all in lowercase
   $Nom = strtolower ($Nom);
   $Nom = substr ("$Nom", 0, 7);  // on garde 7 caractere
   $Prenom = strtolower ($Prenom);

   // try make login by adding the first letter of surename to name.
   $prenom_letter =  substr ("$Prenom", 0, 1);
   $login_tmp = "$Nom"."$prenom_letter";
   $number = 0; //initialize number;
   $check = "failed";
   while($check != "ok") // check if login already existe, and change it if it's the case
   {
       // debug print "login : $login_tmp<br>";
      $check = check_login($db,$login_tmp); // check if login can be used
      if($check != "ok")
      {
         $login_tmp = "$Nom"."$number";
         $number++;
      }
   }
   /* end function */
   return($login_tmp);
}

function check_login($db,$login)   // check if login can be used, return "ok","failed","bad" or "already".
{
    $check = 1; // put check to false by default
    $query = "select (nom) from badlogin where nom='$login' ;";
    $result = pg_exec($db,$query);
    $check = pg_numrows($result); // look if reponse existe;
    $query2 = "select (login) from users where login='$login' ;";
    $result2 = pg_exec($db,$query2);
    $check2 = pg_numrows($result2); // look if response existe;
    $query3 = "select (id) from classes where nom='$login' ;";
    $result3 = pg_exec($db,$query3);
    $check3 = pg_numrows($result3); // look if response existe;
    if(preg_match("/[A-Z]/",$login))
    {
        slislog(warning,"function check_login in lib.inc.php look for MAJ in $login");
        $check5 = 1;
    }
    else
    {
        $check5 = 0;
    }
    if(!(preg_match("/^\D/",$login)))
    {
        $check4 = 1; // login can't begin by decimal char.
    }
    else
    {
        $check4 = 0;
    }
    if($check != 0)
    {
        $val = "failed";
    }
    elseif($check2 != 0)
    {
        $val = "already";
    }
    elseif($check3 != 0)
    {
        $val = "already";
    }
    elseif($check4 != 0)
    {
        $val = "bad";
    }
    elseif($check5 != 0)
    {
        $val = "maj";
    }
    else
    {
        $val = "ok";
    }
    slislog(infos,"function check_login in lib.inc.php return $val");
    return($val);
}

function get_classe_list($db,$type) // return class list for include in table (mode 1) || for include in select on id (mode 2) || text for dbl table include (mode 3)
{
  require("../../slis.conf.php");
  require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
  $query = "select * from classes ;";
  $result = pg_exec($db, $query);
  $numrow = pg_numrows($result);
  $row_number = 0; //first rows
  $checkrown = $numrow ; // check for while

  if($type == "1")
  {
    $i = 0; //color
    while($row_number != $checkrown)
      {
        // extract infos
        $row = pg_fetch_row($result,$row_number);
        if($i & 1)
        {
          $color = '#F2F3FC';
        }
        else
        {
          $color = '#D9F4F4';
        }
        $classeid = StripSlashes($row[0]);
        $classe = StripSlashes($row[1]);
         /* check if user is delete */
        $isdel = is_common_delete($db,$classeid);
        /* new row */
        $row_number++;
        $i++;

        /* output */
        $val .= "<tr bgcolor='$color'>";
        $val .= "<td> <center><a href=edit.php?mod=classe&update=yes&classeid=$classeid><font color=\"#0000FF\">";
        if($isdel == "1")
        {
            $val .= "<s>";
        }
        $val .= "$classe";
        if($isdel == "1")
        {
            $val .= "</s>";
        }
        $val .= "</font></a></center> </TD>\n";
        $val .= "<td><b><a href=\"edit.php?mod=del&id=$classeid\"><font color=#000000>X</font></a></b></td>\n"; // supression des classes
      }
      $val .= "<TR bgcolor=\"#acacac\"><TD><center>$numrow classes</center>\n";
  }
  elseif($type == "2")
  {
      $val .= "<CENTER><SELECT name=\"class\">\n";
      while($row_number != $checkrown)
      {
        $row = pg_fetch_row($result,$row_number);
        $classe_name = StripSlashes($row[1]);
        $idclasse = StripSlashes($row[0]);
        $val .= "<OPTION VALUE=\"$idclasse\">$classe_name</OPTION>\n";
        // count row indentation
        $row_number++;
      }
      $val .= "</SELECT></CENTER>\n";
  }
  elseif($type == "3")
  {
      $val = "<p>";
      while($row_number != $checkrown)
      {
        // extract infos
        $row = pg_fetch_row($result,$row_number);
        $classeid = StripSlashes($row[0]);
        $classe = StripSlashes($row[1]);
         /* check if user is delete */
        $isdel = is_common_delete($db,$classeid);
        /* new row */
        $row_number++;
        $i++;

        /* output */
        //trash
        $val .= "<li>\n";
        $val .= "<a href=\"edit.php?mod=del&id=$classeid\"><img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" title=\"$lang_Delete\" alt=\"$lang_Delete\"></a>&nbsp;";  // delete group
        $val .= "<a href=\"view.php?mode=allgroupusers&gid=$classeid\"><img src=\"../images/group.gif\" width=18 height=18 BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Users\" title=\"$lang_Users\"></a>&nbsp;\n"; // users of group
        // classe name
        $val .= "<a href=edit.php?mod=classe&update=yes&classeid=$classeid><font color=\"#0000FF\">";
        if($isdel == "1")
        {
            $val .= "<s>";
        }
        $val .= "$classe";
        if($isdel == "1")
        {
            $val .= "</s>";
        }
        $val .= "</font></a>&nbsp;\n";
      }
      $val .= "<hr width=\"100%\"><center>$numrow $lang_Groups</center>\n";
  }
  return($val);
}

function get_user_list($db) // retourn user list for include in table
{
  require("../../slis.conf.php");
  require("../inc/lang.inc.php"); // SLIS is multinational now
  $query = "select nom,prenom,login,id,infos,code from users order by nom;";
  $result = pg_exec($db,$query);
  $numrow = pg_numrows($result);
  $i = 0; //color
  $row_number = 0; //first rows
  $checkrown = $numrow ; // check for while

  while($row_number != $checkrown)
    {
      // extract infos
      $row = pg_fetch_row($result,$row_number);
      $nom = StripSlashes($row[0]);
      $prenom = StripSlashes($row[1]);
      $login = StripSlashes($row[2]);
      $userid = StripSlashes($row[3]);
      $userinfos = StripSlashes($row[4]);
      $code = StripSlashes($row[5]);

      /* change empty fields to html space carater */
      if (empty($nom))
      {
         $nom = "&nbsp;";
      }
      if (empty($prenom))
      {
         $prenom = "&nbsp;";
      }
      /* rewrite params */
      $userinfos = rewrite_params($userinfos);
      $code = rewrite_params($code);
      /* new row */
      $row_number++;
      /* check if user is delete */
      $isdel = is_common_delete($db,$userid);
      /* output */
      $val .= "<li>";
      $val .= "<A NAME=\"user".$userid."\"></A>\n"; // make ancre
      if($isdel == "1") // make undelete link
      {
         $val .= "<a href=\"view.php?mode=undelinallusers&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/untrash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Undelete\" title=\"$lang_Undelete\"></a>&nbsp;&nbsp;\n"; // undelete user
      }
      else
      {
         $val .= "<a href=\"view.php?mode=delinallusers&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></a>&nbsp;&nbsp;\n"; // delete user
      }
      if($code)
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&code=".rewrite_params($code)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      else
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$nom";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$prenom</a></font></b>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;\n";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "<I>$login</I>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= " &nbsp;\n";
  }
  if($numrow != 0)
     $val .= "<HR><i><center>$numrow $lang_Users</center></i>\n";
  else
     $val.= "<BR>$lang_no_more";
  return($val);
}

function  check_code($db,$code) // retourne ok if free or bad if in use.
{
    $checkquery = "select code from \"users\" where code='$code' ; ";
    $result = pg_exec($db,$checkquery);
    $numrow = pg_numrows($result);
    if($numrow == 0)
    {
      return("ok");
    }
    else
    {
        return("bad");
    }
}

function add_code($db,$code,$userid) // add code eleve to eleve, return 1 if ok, or error msg.
{
   require("../../slis.conf.php");
   require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
   $checkquery = check_code($db,$code);
   if( ($checkquery == "ok") && (!(empty($code))) )
   {
        $query = "update \"users\" set code='$code' where id='$userid' ;";
        $result2 = pg_exec($db,$query);
        if($result2)
        {
            return("1");
        }
   }
   else
   {
        return(errormsg(center("$code")."$lang_Impossible_code"));
        slislog(warning,"code already in use ' $code ' in function add_code of inc/lib.inc.php");
   }
}

function add_classe($class,$db) // add class to base.
{
   require("../../slis.conf.php");
   require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
   require("../inc/themes.inc.php"); // output themes
   $check = check_login($db,$class);
   if($check == "ok")
   {
      $check_name = CheckName($class);
      if(!($check_name == "ok"))
      {
          $val = $check_name;
          return($val);
          exit;
      }
      $query2 = "insert into classes (nom,modif,nouveau,delete,tovalid) VALUES ('$class','0','1','0','1') ;";
      $result2 = pg_exec($db,$query2);
      if($result2)
      {
         $contenu = "<br><FONT FACE=\"Helvetica,Arial\">\n<CENTER><H3><I>".confirm_msg("$lang_Group $class --> $lang_create")."</I></H3><P>$lang_Valid_for_active_changes<P>\n<B><A HREF=\"./?mode=classe\">$lang_REDO</A></B>\n</FONT></CENTER><br>\n";
      }
   }
   elseif($check == "already")
   {
      $contenu = errormsg("<I> ".font_color($blackcolor,"$lang_Name")." ".font_color($bluecolor,"<b>$class</b>")." ".font_color($blackcolor,"-->")." $lang_already_existe</I></H3>\n<P><B><A HREF=\"./?mode=classe\">$lang_REDO</A></B>");
      slislog(warning,"classe ' $class ' already exist in function add_classe of inc/lib.inc.php");
   }
   elseif($check == "maj")
   {
      $contenu = errormsg("<I> ".font_color($blackcolor,"$lang_Name")." ".font_color($bluecolor,"<b>$class</b>")." ".font_color($blackcolor,"-->")." $lang_Impossible_class_maj</I></H3>\n<P><B><A HREF=\"./?mode=classe\">$lang_REDO</A></B>");
      slislog(warning,"classe ' $class ' already exist in function add_classe of inc/lib.inc.php");
   }
   else
   {
        $contenu = errormsg("<br><I> ".font_color($blackcolor,"$lang_Group")." ".font_color($bluecolor,"<b>$class</b>")." ".font_color($blackcolor,"-->")." $lang_name_use_by_system</I></H3>\n<P><B><A HREF=\"./?mode=classe\">$lang_REDO</A> </B><br>");
        slislog(warning,"classe ' $class ' can't be create in function add_classe of inc/lib.inc.php");
   }
   return($contenu);
}

function select_alias_id($db) // retourn one select in html with user and class with common_id value in param.
{
    $query = "select id,nom,prenom,login from users order by login;";
    $query2 = "select id,nom from classes order by nom;";
    $result = pg_exec($db,$query);     //l users list
    $result2 = pg_exec($db,$query2); //l classes list
    $numrow = pg_numrows($result);
    $numrow2 = pg_numrows($result2);
    $val = "<SELECT NAME=\"aliasid\">\n"; // first ligne
    $checkrown = $numrow ; // check for while
    $checkrown2 = $numrow2 ; // checkion for while 2
     // EXTRACT DATAS
    while($row_number != $checkrown) // user data
    {
      $row = pg_fetch_row($result,$row_number);
      $value = $row[0];
      $nom = $row[1];
      $prenom = $row[2];
      $login = $row[3];
      $val .= "<OPTION VALUE=\"$value\">User: $nom $prenom ($login)</OPTION>\n";
      $row_number++;
    }
    while($row_number2 != $checkrown2) // classe data
    {
      $row2 = pg_fetch_row($result2,$row_number2);
      $value = $row2[0];
      $classe = $row2[1];
      $val .= "<OPTION VALUE=\"$value\">Group: $classe</OPTION>\n";
      $row_number2++;
    }

    $val .= "</SELECT>\n";
    return($val);
}

function get_idtype($db,$id)   // retourn "user" or "classe" in f(x) of id given, or "null" if it'sn't existe
{
    $query = "select nom from users where id='$id';";    // look users
    $query2 = "select nom from classes where id='$id';";  // look classes
    $result = pg_exec($db,$query);     //l ask users
    $result2 = pg_exec($db,$query2); // ask classes
    $numrow = pg_numrows($result);
    $numrow2 = pg_numrows($result2);
    if( ($numrow == 1) && ($numrow2 != 1) )
    {
        $val = "users";
    }
    elseif( ($numrow2 == 1) && ($numrow != 1) )
    {
        $val ="classe";
    }
    else
    {
       $val ="null";
    }
    return($val);
}

function addgroup($db,$iduser,$idgroup,$primary) // insert data into sql table "groups" and return "ok","already"  or "failed".
{
   $check = 0; // check for doing query 2;
   $query = "select  userid,classeid from \"groups\" where userid='$iduser' and classeid='$idgroup';";
   $result = pg_exec($db,$query);     // check if existe
   $numrow = pg_numrows($result);
   if($primary != 1)
   {
      if($numrow == 0)
      {
          $query2 = "insert into \"groups\" (\"userid\",\"classeid\",\"modif\",nouveau\",\"delete\",\"tovalid\",\"primary\") VALUES('$iduser','$idgroup','0','1','0','1','0');";
      }
      else
      {
          $check = 1;
          $val = "already";
      }
   }
   else   // check that affectation don't existe.
   {
      if($numrow == 0)
      {
           $query2 = "insert into \"groups\" (\"userid\",\"classeid\",\"modif\",\"nouveau\",\"delete\",\"tovalid\",\"primary\") VALUES('$iduser','$idgroup','0','1','0','1','1');";
      }
      else
      {
           $query2 = "update \"groups\" set \"modif\"='0',\"tovalid\"='1',\"primary\"='1' where  userid='$iduser' and classeid='$idgroup' ;";
      }
   }
   if($check == 0)
   {
        $result2 = pg_exec($db,$query2); // insert data
   }
   if($result2)
   {
        $val = "ok";
   }
   elseif(!($result2) && ($check == 0))
   {
        $val = "failed";
   }
   return($val);
}

function get_userid($db,$login) // return common id for an existing login
{
   $query = "select  id from users where login='$login';";
   $result = pg_exec($db,$query);
   $row = pg_fetch_row($result,"0");
   $val = $row[0];
   return($val);
}

function get_userlogin($db,$code) // return login  for an existing id
{
   $query = "select  login from users where code='$code';";
   $result = pg_exec($db,$query);
   $row = pg_fetch_row($result,"0");
   $val = $row[0];
   return($val);
}

function select_users($db) // return users list for one select with param='userid'  that is the user's tuple common_id.
{
    $query = "select id,nom,prenom,login from users order by login;";
    $result = pg_exec($db,$query);     // users list
    $numrow = pg_numrows($result);
    $val = "<SELECT NAME=\"userid\">\n"; // first ligne
    $checkrown = $numrow ; // check for while
     // EXTRACTDES DATAS
    while($row_number != $checkrown) // user data
    {
      $row = pg_fetch_row($result,$row_number);
      $value = $row[0];
      $nom = $row[1];
      $prenom = $row[2];
      $login = $row[3];
      $fullname = "$nom $prenom";
      $val .= "<OPTION VALUE=\"$value\">$fullname ($login)</OPTION>\n";
      $row_number++;
    }
    $val .= "</SELECT>\n";
    return($val);
}

function select_classe($db) // return classes list for include in a select with param 'classeid' = their commond_id
{
    $query2 = "select id,nom from classes order by nom;";
    $result2 = pg_exec($db,$query2); //l classes list
    $numrow2 = pg_numrows($result2);
    $val = "<SELECT NAME=\"classeid\">\n"; // first ligne
    $checkrown2 = $numrow2 ; // check for while 2
     // EXTRACT DATAS
    while($row_number2 != $checkrown2) // classes datas
    {
      $row2 = pg_fetch_row($result2,$row_number2);
      $value = $row2[0];
      $classe = $row2[1];
      $val .= "<OPTION VALUE=\"$value\">$classe</OPTION>\n";
      $row_number2++;
    }

    $val .= "</SELECT>\n";
    return($val);
}

function get_name($db,$common_id) // return full name of users or classe.
{
    $type = get_idtype($db,$common_id);
    if($type ==  "users")
    {
        $query = "SELECT nom,prenom from users where id='$common_id';";
        $result = pg_exec($db,$query);
        $row = pg_fetch_row($result,0);
        $val = $row[0];
        $val .= " ";
        $val .= $row[1];
    }
    elseif($type == "classe")
    {
        $query = "SELECT nom from classes where id='$common_id';";
        $result = pg_exec($db,$query);
        $row = pg_fetch_row($result,0);
        $val = $row[0];
    }
    else
    {
        $val = "Bad params on get_name";
    }
    return($val);
}

function get_user_classe($db,$userid)  // return the class list of one user with <BR> like separator.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    $query = "SELECT classeid from \"groups\" where userid='$userid';"; // id of classes from multigroupe table
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    $test = $checkrown - 1;  // test for new ligne
    $username = get_name($db,$userid);
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $strike = is_groups_delete($db,$tmpval,$userid);
        if($strike == "1")
        {
            $val .= "<s>";
        }
        $groupname = get_name($db,$tmpval); // get name of classe
        $val .= $groupname;
        if($strike == "1")
        {
            $val .= "</s>";
        }
        $val .= "&nbsp;<A HREF=edit.php?mod=del&type2=group&userid=$userid&classeid=$tmpval><img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" ALT=\"$lang_Delete $username $lang_of $groupname\" TITLE=\"$lang_Delete $username $lang_of $groupname\"></A>&nbsp;";
        if($row_number != $test)
        {
            $val .= "<br>"; // new ligne
        }
        // count row indentation
        $row_number++;
    }
    return($val);
}

function add_primary_class($db,$userid,$classid) // add primary class in tbl groups en return "ok" or "error";
{
    // make sur we don't have one primary class before
    del_primary_class($db,$userid);
    if($classid != "000") // make sure a new primary class is selected
    {
        $check = addgroup($db,$userid,$classid,"1");
    }
    if($check == "ok")
    {
         return("ok");
    }
    else
    {
        return("error");
        slislog(warning,"classeid ' $classid ' can't be the primary class for userid '$userid' in function add_primary_class of inc/lib.inc.php");
    }
}

function del_primary_class($db,$userid) // check and remove old primary if one.
{
    $query1 = "SELECT classeid from \"groups\" where userid='$userid' and \"primary\"='Yes';";
    $result1 = pg_exec($db,$query1);
    $numrow1 = pg_numrows($result1);
    if($numrow1 == 1)
    {
        $row1 = pg_fetch_row($result1,0);
        $classid = StripSlashes($row1[0]);
        $query2 = "UPDATE \"groups\" set \"primary\"='No' where userid='$userid' and classeid='$classid';";
        pg_exec($db,$query2);
    }
}


function is_primary_class($db,$userid,$classid) // return 0 if it isn't or 1 if it is.
{
    $query1 = "SELECT classeid from \"groups\" where userid='$userid' and \"primary\"='Yes';";
    $result1 = pg_exec($db,$query1);
    $numrow1 = pg_numrows($result1);
    if($numrow1 == 1)
    {
        $row1 = pg_fetch_row($result1,0);
        $user_p_class_id = StripSlashes($row1[0]);
    }
    else
    {
        $user_p_class = 0;
    }
    if($user_p_class_id == $classid)
    {
        $val = 1;
    }
    else
    {
        $val = 0;
    }
    return($val);
}

function get_user_select_primary_class($db,$uid) // return a html select whith name of all class and user class selected. in array[0] end 1 if have p classe or 0 if haven't in array[1];
{
    global $lang_Nothing;
    $query = "select * from classes ;";
    $result = pg_exec($db, $query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    $val[0] .= "<SELECT name=\"class\">\n"; // init select
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $classe_name = StripSlashes($row[1]);
        $idclasse = StripSlashes($row[0]);
        $is_primary = is_primary_class($db,$uid,$idclasse);
        if($is_primary == 1)
        {
            $val[0] .= "<OPTION VALUE=\"$idclasse\" SELECTED>$classe_name</OPTION>\n";
            $flag1 = "ok";
            $val[1] = "1";
        }
        else
        {
             $val[0] .= "<OPTION VALUE=\"$idclasse\">$classe_name</OPTION>\n";
        }
        // count row indentation
        $row_number++;
    }
    // add empty class selected
    if(!($flag1 == "ok"))  // add empty classe select
    {
        $val[0] .= "<OPTION VALUE=\"000\" SELECTED>". $lang_Nothing ."</OPTION>\n";
        $val[1] .= "0";
    }
    $val[0] .= "</SELECT>\n";  // end select
    return($val);
}

function undelete_common($db,$id) // undelete all infos on classe or user. and return "ok" if all deleted or "error."
{
    $type = get_idtype($db,$id); // undelete type
    if($type == "users")       // user undel.
    {
        $query = "update \"users\" set delete='0' where id='$id' ;"; //table users
        $query2 = "update \"groups\" set delete='0' where userid='$id' ;"; // table groups
        $query3 = "update \"alias\" set delete='0' where id='$id' ;"; //table alias
        $result = pg_exec($db,$query); // users
        $result2 = pg_exec($db,$query2); // groups
        $result3 = pg_exec($db,$query3); // alias
        if(!($result))
        {
            $val = "error";
            slislog(warning,"can't undelete common userid ' $id ' in function undelete_common of inc/lib.inc.php");
        }
        else
        {
            $val = "ok";
        }
    }
    elseif($type == "classe")  // classe undel
    {
        $query = "update \"classes\" set delete='0' where id='$id' ;"; //table users
        $query2 = "update \"groups\" set delete='0' where classeid='$id' ;"; // table group
        $query3 = "update \"alias\" set delete='0' where id='$id' ;"; //table alias
        $result = pg_exec($db,$query); // class
        $result2 = pg_exec($db,$query2); // group
        $result3 = pg_exec($db,$query3); // alias
        if(!($result))
        {
            $val = "error";
            slislog(warning,"can't undelete common classid ' $id ' in function undelete_common of inc/lib.inc.php");
        }
        else
        {
            $val = "ok";
        }
    }
    else
    {
      $val ="error";
       slislog(warning,"can't undelete common ' $id ' ( type inconow ) in function undelete_common of inc/lib.inc.php");
    }
    return($val);
}

function delete_common($db,$id) // delete all infos on classe or user. and return "ok" if all deleted or "error."
{
    $type = get_idtype($db,$id); // delete type
    if($type == "users")       // user del.
    {
        $query = "update \"users\" set delete='1', tovalid='1' where id='$id' ;"; //table users
        $query2 = "update \"groups\" set delete='1', tovalid='1' where userid='$id' ;"; // table groups
        $query3 = "update \"alias\" set delete='1', tovalid='1' where id='$id' ;"; //table alias
        $result = pg_exec($db,$query); // users
        $result2 = pg_exec($db,$query2); // groups
        $result3 = pg_exec($db,$query3); // alias
        if(!($result))
        {
            $val = "error";
            slislog(warning,"can't delete common userid ' $id ' in function delete_common of inc/lib.inc.php");
        }
        else
        {
            $val = "ok";
        }
    }
    elseif($type == "classe")  // classe del
    {
        $query = "update \"classes\" set delete='1', tovalid='1' where id='$id' ;"; //table users
        $query2 = "update \"groups\" set delete='1', tovalid='1' where classeid='$id' ;"; // table group
        $query3 = "update \"alias\" set delete='1', tovalid='1' where id='$id' ;"; //table alias
        $result = pg_exec($db,$query); // users
        $result2 = pg_exec($db,$query2); // group
        $result3 = pg_exec($db,$query3); // alias
        if(!($result))
        {
            $val = "error";
            slislog(warning,"can't delete common classid ' $id ' in function delete_common of inc/lib.inc.php");
        }
        else
        {
            $val = "ok";
        }
    }
    else
    {
      $val ="error";
       slislog(warning,"can't delete common ' $id ' ( type inconow ) in function delete_common of inc/lib.inc.php");
    }
    return($val);
}

function save_oldvalue($db,$common_id) // save old fields in table oldvalue befor a valid. return "ok" or "failed"
{
    if(!($common_id)) { return("error"); exit; } // exit if bad params.
    $type =  get_idtype($db,$common_id);
    $needquery = "select * from oldvalue where id='$common_id';";
    $needresult = pg_exec($db,$needquery);
    $neednumrow = pg_numrows($needresult);
    if($neednumrow == "0")
    {
        if ($type == "users")
        {
            $query = "select nom,prenom,infos,login,passwd,code from users where id='$common_id';"; // users
            $result = pg_exec($db,$query); // extract users value
            $row = pg_fetch_row($result,0);
            $nom = $row[0];
            $prenom = $row[1];
            $infos = $row[2];
            $login = $row[3];
            $passwd = $row[4];
            $code = $row[5];
            $query2 = "insert into \"oldvalue\" (id,nom,prenom,infos,login,passwd,code) VALUES ('$common_id','$nom','$prenom','$infos','$login','$passwd','$code') ;"; // new tuple whith old value
            $result2 = pg_exec($db,$query2); // save old value user tuple
            if(!($result2))
            {
                $val = "failed";
            }
            else
            {
                $val = "ok";
            }
        }
        elseif($type == "classe")
        {
             $query = "select nom from classes where id='$common_id';"; // classe
             $result = pg_exec($db,$query); // extract classe name
             $row = pg_fetch_row($result,0);
             $nom = $row[0];
             $query2 = "insert into \"oldvalue\" (id,nom) VALUES ('$common_id','$nom') ;"; // new tuple whith old classe value
             $result2 = pg_exec($db,$query2); // save old value classe tuple
             if(!($result2))
             {
                 $val = "failed";
             }
             else
             {
                 $val = "ok";
             }
        }
    }
    else
    {
        $val = "ok"; // already modified but no yet validate.
    }
    return($val);
}

function get_modif_list($db) // return modifications list befor valid.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now

    // group deleted
    $query = "select userid,classeid from \"groups\" where delete='Yes' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $userid= StripSlashes($row[0]);
        $user = get_name($db,$userid);
        $classeid = StripSlashes($row[1]);
        $classe = get_name($db,$classeid);
        $val .=  "<B>$lang_modif_del_affiliation : ". font_color("#0000FF","$user <--> $classe")."</b>\n";
        $val .= "<br>"; // new ligne
        // count row indentation
        $row_number++;
    }
    // group add
    $val .= "<p>\n";
    $query = "select userid,classeid from \"groups\" where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $userid= StripSlashes($row[0]);
        $user = get_name($db,$userid);
        $classeid = StripSlashes($row[1]);
        $classe = get_name($db,$classeid);
        $val .= "<B>$lang_modif_add_affiliation : ". font_color("#0000FF","$user <--> $classe")."</b>\n";
        $val .= "<br>"; // new ligne
        // count row indentation
        $row_number++;
    }
     // alias deleted
    $query = "select alias from alias where delete='Yes' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $alias= StripSlashes($row[0]);
        $val .=  "<B>$lang_modif_del_alias : ".font_color("#0000FF","$alias");
        $val .= "<br>\n"; // new ligne
        // count row indentation
        $row_number++;
    }
    //alias add
    $val .= "<p>\n";
    $query = "select alias from alias where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $alias= StripSlashes($row[0]);
        $val .= "<B>$lang_modif_add_alias : ".font_color("#0000FF","$alias");
        $val .= "<br>"; // new ligne
        // count row indentation
        $row_number++;
    }
    // users deleted
    $query = "select id from users where delete='Yes' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .=  "<B>$lang_modif_del_user : ";
        $val2.= get_name($db,$tmpval)."\n"; // get user name.
        $val .=  font_color("#0000FF","$val2");
        $val .= "<br>"; // new ligne
        // count row indentation
        $row_number++;
    }
    // user changes
    $val .= "<p>\n";
    $query = "select id from users where modif='Yes' and nouveau='No' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .=  "<B>$lang_modif_modif_user : ";
        $val2 = get_name($db,$tmpval)."\n"; // get user classe
        $val .= font_color("#0000FF","$val2");
        $val .= "<br>"; // new ligne
        // count row indentation
        $row_number++;
    }
    // user add
    $val .= "<p>\n";
    $query = "select id from users where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ;
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .= "<B>$lang_modif_add_user : ";
        $val2 = get_name($db,$tmpval)."\n";
        $val .= font_color("#0000FF","$val2");
        $val .= "<br>";
        // count row indentation
        $row_number++;
    }
    // classe deleted
    $val .= "<p>\n";
    $query = "select id from classes where delete='Yes' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ;
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .=  "<B>$lang_modif_del_group : ";
        $val2 = get_name($db,$tmpval)."\n";
        $val .= font_color("#0000FF","$val2");
        $val .= "<br>"; //saut de ligne
        // count row indentation
        $row_number++;
    }
    // classe changes
    $val .= "<p>\n";
    $query = "select id from classes where modif='Yes' and nouveau='No' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ;
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .=  "<B>$lang_modif_modif_group : ";
        $val2 = get_name($db,$tmpval)."\n";
        $val .= font_color("#0000FF","$val2");
        $val .= "<br>";
        // count row indentation
        $row_number++;
    }
    // classe add
     $val .= "<p>\n";
    $query = "select id from classes where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $test = $numrow - 1;
    $checkrown = $numrow ;
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .= "<B>$lang_modif_add_group : ";
        $val2 = get_name($db,$tmpval)."\n";
        $val .= font_color("#0000FF","$val2");
        if($row_number != $test)
        {
            $val .= "<br>";
        }
        // count row indentation
        $row_number++;
    }
    // options changes
    $val .= "<p>\n";
    $query = "select name from options where tovalid='1' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ;
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $tmpval= StripSlashes($row[0]);
        $val .=  "<B>$lang_Options : ";
        $val2 = pg_result($result,$row_number,"name")."\n";
        $val .= font_color("#0000FF","$val2");
        $val .= "<br>";
        // count row indentation
        $row_number++;
    }
    return($val);
}

function undo_modif($db)  // delete modifications that are no validated and restaure old datas. retourn "ok" ou "failed";
{
    // alias deleted
    $query = "delete from \"alias\" where delete='Yes' ;";
    $result = pg_exec($db,$query);

    // alias add
    $query = "delete from \"alias\" where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);

    // group deleted
    $query = "delete from \"groups\" where delete='Yes' ;";
    $result = pg_exec($db,$query);

    // group add
    $query = "delete from \"groups\" where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);

    // users deleted
    $query = "update users set delete='No' where delete='Yes' ;";
    $result = pg_exec($db,$query);

    // user changes
    $query = "select id from users where modif='Yes' and nouveau='No' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $id= StripSlashes($row[0]);
        $query2 = "select * from oldvalue where id='$id';";
        $result2 = pg_exec($db,$query2);
        $numrow2 = pg_numrows($result2);
        if($numrow2 == "1")
        {
            $row2 = pg_fetch_row($result2,"0");
            $oid = $row2[0];
            $onom = $row2[1];
            $oprenom = $row2[2];
            $oinfos = $row2[3];
            $ologin = $row2[4];
            $opasswd = $row2[5];
            $ocode = $row2[6];
            // begin query
            $qtem1 = "update \"users\" set ";
            // build query
            if(!(empty($onom)))
            {
                $qtem1 .= "nom='$onom',";
            }
            if(!(empty($oprenom)))
            {
                $qtem1 .= "prenom='$oprenom',";
            }
            if(!(empty($oinfos)))
            {
                $qtem1 .= "infos='$oinfos',";
            }
            if(!(empty($ologin)))
            {
                $qtem1 .= "login='$ologin',";
            }
            if(!(empty($opasswd)))
            {
                $qtem1 .= "passwd='$opasswd',";
            }
            if(!(empty($ocode)))
            {
                $qtem1 .= "code='$ocode',";
            }
            // end query
            $qtem1 .= "modif='0',nouveau='0',delete='0',tovalid='0' where id='$oid';";
            // exec alls querys
            $query4 = $qtem1;
            $result4 = pg_exec($db,$query4);
            if($result4)
            {
                $query5 =  "delete from oldvalue where id='$id' ;";
                pg_exec($db,$query5);
            }
        }
        // count row indentation
        $row_number++;
    }
    // user add
    $query2 = "select id from users where nouveau='Yes' and delete='No';";
    $result2 = pg_exec($db,$query2);
    $numrow = pg_numrows($result2);
    $row_number = 0; // first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)   //remove md5 and crypt passwd
    {
        $row2 = pg_fetch_row($result2,$row_number);
        $id= StripSlashes($row2[0]);
        $query3 = "delete from password where id='$id' ;";
        $result3 = pg_exec($db,$query3);
        $row_number++;
    }
    $query = "delete from users where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);

    // classe deleted
    $query = "update classes set delete='No' where delete='Yes' ;";
    $result = pg_exec($db,$query);

    // classe changes
    $query = "select id from classes where modif='Yes' and nouveau='No' and delete='No' ;";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; // first rows
    $checkrown = $numrow ; // check for while
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $id= StripSlashes($row[0]);
        $query2 = "select * from oldvalue where id='$id';";
        $result2 = pg_exec($db,$query2);
        $numrow2 = pg_numrows($result2);
        if($numrow2 == "1")
        {
            $row2 = pg_fetch_row($result2,"0");
            $oid = $row2[0];
            $onom = $row2[1];
            $oprenom = $row2[2];
            $oinfos = $row2[3];
            $ologin = $row2[4];
            $opasswd = $row2[5];
            // begin query
            $qtem1 = "update \"classes\" set ";
            // build query
            if(!(empty($onom)))
            {
                $qtem1 .= "nom='$onom',";
            }
            if(!(empty($oprenom)))
            {
                $qtem1 .= "prenom='$oprenom',";
            }
            if(!(empty($oinfos)))
            {
                $qtem1 .= "infos='$oinfos',";
            }
            if(!(empty($ologin)))
            {
                $qtem1 .= "login='$ologin',";
            }
            if(!(empty($opasswd)))
            {
                $qtem1 .= "passwd='$opasswd',";
            }
            // end query
            $qtem1 .= "modif='0',nouveau='0',delete='0',tovalid='0' where id='$oid';";
            // exec alls querys
            $query4 = $qtem1;
            $result4 = pg_exec($db,$query4);
            if($result4)
            {
                $query5 =  "delete from oldvalue where id='$id' ;";
                pg_exec($db,$query5);
            }
        }
        // count row indentation
        $row_number++;
    }

    // classe add
    $query = "delete from classes where nouveau='Yes' and delete='No' ;";
    $result = pg_exec($db,$query);

    // runtime options
    $query = "update options set value=old_value,tovalid='0',old_value='' where tovalid='1'";
    $result = pg_exec($db,$query);
 
    return("ok");
}

function get_alias_list($db,$common_id) // retourn alias list by user or by classes.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    $query = "SELECT alias from \"alias\" where id='$common_id';";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    $row_number = 0; //first rows
    $checkrown = $numrow ; // check for while
    $test = $checkrown - 1;  // test for new ligne
    while($row_number != $checkrown)
    {
        $row = pg_fetch_row($result,$row_number);
        $alias = StripSlashes($row[0]);
        $strike = is_alias_delete($db,$common_id,$alias);
        if($strike == "1")
        {
            $val .= "<s>";
        }
        $val .= $alias; // get name of classe
        if($strike == "1")
        {
            $val .= "</s>";
        }
        $val .= "&nbsp;<A HREF=edit.php?mod=del&type2=alias&common_id=$common_id&alias=$alias><img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></A>&nbsp;";
        if($row_number != $test)
        {
            $val .= "<br>"; // new ligne
        }
        // count row indentation
        $row_number++;
    }
    return($val);
}

function get_class_id($db,$name) // return id of classe if existe or 0 if none.
{
    $query = "SELECT id from \"classes\" where nom='$name';";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    if($numrow == 0)
    {
        $val = 0;
    }
    elseif($numrow == 1)
    {
        $row = pg_fetch_row($result,"0");
        $val = StripSlashes($row[0]); // class_id
    }
    else
    {
        print errormsg("Error in lib.inc.php, f(x) get_class_id = database table classes corrupted.");
         slislog(warning,"table classes corrupt can't get classid for '$name' in function get_class_id of inc/lib.inc.php");
        exit;
    }
    return($val);
}

function check_user_code($db,$code,$userid) // return 1 if is user code or 0 if it's isn't.
{
    $checkquery = "select code from \"users\" where id='$userid' ; ";
    $result = pg_exec($db,$checkquery);
    $numrow = pg_numrows($result);
    if($numrow == 1)
    {
        $row = pg_fetch_row($result,"0");
        $check = StripSlashes($row[0]); // user code
    }
    if($code == $check)
    {
        return("1");
    }
    else
    {
        return("0");
    }
}

function rewrite_params($params) // return params convert for include in a href.
{
    $params = rawurlencode($params);
    return($params);
}

function undo_rewrite_params($params) // return params convert from url encode to ascii
{
    $params = rawurldecode($params);
    return($params);
}

function add_alias($db,$alias,$id) // return "ok" or error msg
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    $alias =  preg_replace("/\s/","-",$alias); // replace all space by -
    $check = check_alias($db,$alias);
    if($check == "0")
    {
        $query = "insert into \"alias\" (id,alias,modif,nouveau,delete,tovalid) VALUES ('$id','$alias','0','1','0','1');";
        $v_query = pg_exec($db,$query);
        if($v_query)
        {
            $val = "ok";
        }
        else
        {
            $val = "$lang_Insert_error_table : alias";
            slislog(error,"can't insert in slq table ' alias ' in function add_alias of inc/lib.inc.php");
        }
    }
    else
    {
        $val = $check;
    }
    return($val);
}

function check_alias($db,$alias) // return 0 if 'ok' or "error msg" if not.
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    require("../inc/themes.inc.php");
    if( preg_match("/\@/",$alias) ) // check @
    {
        $check = 1;
    }
    $query = "select id from \"alias\" where alias='$alias';";
    $result = pg_exec($db,$query);
    $numrow = pg_numrows($result);
    if( ($numrow == 0) && ($check != 1) )
    {
        $val = "0";
    }
    else
    {
        if($check)
        {
          $val = "<b>$alias</b> : $lang_Name_bad_caracters";
          slislog(warning,"bad caracters in alias '$alias '. Function check_alias of inc/lib.inc.php");
        }
        else
        {
          $row = pg_fetch_row($result,"0");
          $id = StripSlashes($row[0]);
          $name = get_name($db,$id);
          $val =  "$lang_Alias $lang_already_use_by ".font_color($bluecolor,$name);
        }
    }
    return($val);
}

function menu_item($href,$link,$experimental,$one_interface,$expert) // return menu item string in html formated by level
{
  global $experimental_menu, $one_interface_menu ,$expert_menu;
  if ($expert == 1) {$i="<I>";$si="</I>";}
  if ($experimental == 1) {$i="<I>";$si=" (experimental)</I>";}
  if
     (
        (($experimental && $experimental_menu) || (!$experimental))
      && (($one_interface && $one_interface_menu) || (!$one_interface))
      && (($expert && $expert_menu) || (!$expert))
     )
  { return "$i<LI><A HREF=\"$href\">$link</A>$si\n"; }
  else
  { return "";}
}

function n_interfaces() // returns the number of interfaces of this SLIS inclunding lo
{
  exec("wc -l /proc/net/dev|awk '{print \$1}'",$wc);
  $n=$wc[0]-2;
  if ($n < 0) { $n=3; } // Then, there's a problem. Let's return the default (1 lo and 2 eth)
  return $n;
}

function stop_if_no_admin() // Halt the script and ask for configuration of the admin if it's not already done
{
  global $BASE,$lang_Initialization,$lang_No_admin_params,$lang_Next;
  global $first_tcolor,$sec_tcolor,$text,$border,$titre_color;
  $params=file("$BASE/params_admin.txt");
  if (!preg_match("/^.+\@.+\..+/",$params[2])) {
    $text = "<CENTER><FONT FACE=Helvetica,Arial>". $lang_No_admin_params;
    $text .= "\n<P><B><A HREF=../admin/administrator.php>$lang_Next...</A></B></FONT></CENTER><BR><P>\n";
    $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_Initialization,$titre_color);
    $val = center($val);
    $val = saut(2)."$val";
    print "$val\n";
    print endHTML();
    exit;
  }
}

function get_file_content($file) // return the "cat" of arguments full path file
{
    $params=file("$file");
    while($line = array_shift($params))
    {
      $val .= "<br>".$line;
    }
    return($val);
}

function get_old_modif($QUEUE)  // return a list of val were are modify by old system's scripts
{
  require("../../slis.conf.php");
  require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
  require("../inc/themes.inc.php");
  if(file_exists("$QUEUE/filtrage_ip"))
  {
      $val .= "<P><B>$lang_oldmodifs_IPFiltering :</B><PRE>" ;
      $val .= get_file_content("$QUEUE/filtrage_ip");
      $val .= "</PRE>\n";
  }
  if(file_exists("$QUEUE/denied_url"))
  {
      $val .= "<P><B>$lang_oldmodifs_bad_addr :</B><PRE>";
      $val .= get_file_content("$QUEUE/denied_url");
      $val .= "</PRE>\n";
  }
  if(file_exists("$QUEUE/denied_url_purge"))
  {
      $val .= "<P><B>$lang_oldmodifs_bad_addr :</B><PRE>";
      $val .= "purge totale.";
      $val .= "</PRE>\n";
  }
  if(file_exists("$QUEUE/subnets"))
  {
      $val .= "<P><B>$lang_oldmodifs_Active_subnet</B>\n";
  }
  if(file_exists("$QUEUE/subn_hor"))
  {
      $val .= "<P><B>$lang_oldmodifs_Modif_subnet</B>\n";
  }
  if(file_exists("$QUEUE/webmaster"))
  {
      $webmaster=get_file_content("$QUEUE/webmaster");
      $val .= "<P><B>$lang_oldmodifs_Nomination_of_webmaster </B><I>$webmaster</I>\n";
  }
  if(file_exists("$QUEUE/cybgroups"))
  {
      $val .= "<P><B>$lang_oldmodifs_Modif_cyber_groups</B>\n";
  }
  if(file_exists("$QUEUE/pushsite.slis"))
  {
      $val .= "<P><B>$lang_oldmodifs_Web_conf.</B>\n";
  }
  if(file_exists("$QUEUE/pushsite.start"))
  {
      $val .= "<P><B>$lang_oldmodifs_Web_active_app.</B>\n";
  }
  if(file_exists("$QUEUE/pushsite.stop"))
  {
      $val .= "<P><B>$lang_oldmodifs_interupt_replication.</B>\n";
  }
  if(file_exists("$QUEUE/pushsite.purge"))
  {
      $val .= "<P><B>$lang_oldmodifs_Web_purge.</B>\n";
  }
  if(file_exists("$QUEUE/wget.slis"))
  {
      $val .= "<P><B>$lang_oldmodifs_Aspiration_web.</B>\n";
  }
  if(file_exists("$QUEUE/wget.start"))
  {
      $val .= "<P><B>$lang_oldmodifs_Start_aspiration.</B>\n";
  }
  if(file_exists("$QUEUE/wget.stop"))
  {
      $val .= "<P><B>$lang_oldmodifs_Stop_aspiration.</B>\n";
  }
  if(file_exists("$QUEUE/wget.purge"))
  {
      $val .= "<P><B>$lang_oldmodifs_Purge_aspiration.</B>\n";
  }
  if(file_exists("$QUEUE/wget.del"))
  {
      $val .= "<P><B>$lang_oldmodifs_Delete_site_aspiration.</B>\n";
  }
  if(file_exists("$QUEUE/adsl"))
  {
      $val .= "<P><B>$lang_oldmodifs_ADSL_start.</B><PRE>" ;
      $val .= get_file_content("$QUEUE/adsl");
      $val .= "</PRE>\n";
  }
  if(file_exists("$QUEUE/adsl-params"))
  {
      $val .= "<P><B>$lang_oldmodifs_ADSL_modifs</B><PRE>" ;
      $val .= get_file_content("$QUEUE/adsl-params");
      $val .= "</PRE>\n";
  }
  return($val);
}


function sec_to_time($seconds)  // returns a string formated as hh:mm:ss for the number of seconds specified
{
  $mm=floor($seconds/60);
  $ss=$seconds-$mm*60;
  $hh=floor($mm/60);
  $mm=$mm-$hh*60;
  if ($ss < 10) { $ss = "0". $ss; }
  if ($mm < 10) { $mm = "0". $mm; }
  if ($hh < 10) { $hh = "0". $hh; }
  return "$hh:$mm:$ss";
}

function start_stop_form($url,$action) // returns a form asking for a start date and a stop date. $url is the script called by this form and $action is the value of the hidden variable action.
{
  global $LANGUAGE,$lang_stats_Report_end,$lang_stats_Report_begin,$lang_stats_Proxy_logs_simple;
  $y_now=date("Y",time());
  $y_prev=$y_now-1;
  $m_now=date("m",time());
  $d_now=date("d",time());

  // FRENCH DATE REPRESENTATION
  if ($LANGUAGE=="french") {
    $text =  "<FORM ACTION=\"$url\" METHOD=get>\n";
    $text .= "<INPUT TYPE=Hidden NAME=action VALUE=\"$action\">\n";
    $text .= "<TABLE BORDER=0>\n";
    $text .= "<TR><TD>$lang_stats_Report_begin</TD>\n";
    $text .= "<TD><SELECT NAME=begin_d>\n";
    for ($i=1;$i<=31;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      $text .= "<OPTION VALUE=$i>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>/</TD>\n";
    $text .= "<TD><SELECT NAME=begin_m>\n";
    for ($i=1;$i<=12;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $m_now) { $selected="SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>/</TD>\n";
    $text .= "<TD><SELECT NAME=begin_y>\n";
    $text .= "<OPTION VALUE=$y_prev>$y_prev\n";
    $text .= "<OPTION VALUE=$y_now SELECTED>$y_now\n";
    $text .= "</SELECT></TD></TR>\n";

    $text .= "<TR><TD>$lang_stats_Report_end</TD>\n";
    $text .= "<TD><SELECT NAME=end_d>\n";
    for ($i=1;$i<=31;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $d_now) { $selected = "SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>/</TD>\n";
    $text .= "<TD><SELECT NAME=end_m>\n";
    for ($i=1;$i<=12;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $m_now) { $selected="SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>/</TD>\n";
    $text .= "<TD><SELECT NAME=end_y>\n";
    $text .= "<OPTION VALUE=$y_prev>$y_prev\n";
    $text .= "<OPTION VALUE=$y_now SELECTED>$y_now\n";
    $text .= "</SELECT></TD>\n";
    $text .= "</TR></TABLE>\n";
    if ($action=='squid-report') {
    	$text .="<CENTER><INPUT TYPE=checkbox name=logs_squid_s value=true>$lang_stats_Proxy_logs_simple</CENTER>\n";
    	}
    $text .= "<CENTER><HR><INPUT TYPE=SUBMIT VALUE=OK></CENTER></FORM>\n";
  }

  // OTHER COUNTRY
  else {
    $text =  "<FORM ACTION=\"$url\" METHOD=get>\n";
    $text .= "<INPUT TYPE=Hidden NAME=action VALUE=\"$action\">\n";
    $text .= "<TABLE BORDER=0>\n";
    $text .= "<TR><TD>$lang_stats_Report_begin</TD>\n";

    $text .= "<TD><SELECT NAME=begin_m>\n";
    for ($i=1;$i<=12;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $m_now) { $selected="SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>-</TD>\n";

    $text .= "<TD><SELECT NAME=begin_d>\n";
    for ($i=1;$i<=31;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      $text .= "<OPTION VALUE=$i>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>-</TD>\n";

    $text .= "<TD><SELECT NAME=begin_y>\n";
    $text .= "<OPTION VALUE=$y_prev>$y_prev\n";
    $text .= "<OPTION VALUE=$y_now SELECTED>$y_now\n";
    $text .= "</SELECT></TD></TR>\n";

    $text .= "<TR><TD>$lang_stats_Report_end</TD>\n";

    $text .= "<TD><SELECT NAME=end_m>\n";
    for ($i=1;$i<=12;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $m_now) { $selected="SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>-</TD>\n";

    $text .= "<TD><SELECT NAME=end_d>\n";
    for ($i=1;$i<=31;$i++) { 
      if ($i < 10) { $val="0". $i; }
      else { $val=$i; }
      if ($i == $d_now) { $selected = "SELECTED"; }
      else { $selected = ""; }
      $text .= "<OPTION VALUE=$i $selected>$val\n"; 
    }
    $text .= "</SELECT></TD><TD>-</TD>\n";

    $text .= "<TD><SELECT NAME=end_y>\n";
    $text .= "<OPTION VALUE=$y_prev>$y_prev\n";
    $text .= "<OPTION VALUE=$y_now SELECTED>$y_now\n";
    $text .= "</SELECT></TD>\n";
    $text .= "</TR></TABLE>\n";
    if ($action=='squid-report') {
    	$text .="<CENTER><INPUT TYPE=checkbox name=logs_squid_s value=checked>$lang_stats_Proxy_logs_simple</CENTER>\n";
    	}
    $text .= "<CENTER><HR><INPUT TYPE=SUBMIT VALUE=OK></CENTER></FORM>\n";
  }

  return $text;
}

function isip($ip) { // returns true if the param is a valid ip address
  if (preg_match("/^(\d{1,3}\.){3}\d{1,3}/",$ip)) { $ok=1; }
  elseif ($ip=="all") { $ok=1; }
  elseif ($ip=="public") { $ok=1; }
  elseif ($ip=="local") { $ok=1; }
  elseif ($ip=="slis_public") { $ok=1; }
  elseif ($ip=="slis_local") { $ok=1; }
  elseif ($ip=="smarthost") { $ok=1; }
  else {$ok=0; }
  return $ok;
}

function option_link($dbh,$option,$link,$value) { // returns a link for the options editing menu (admin/options.php)
  $query = "select value,tovalid from options where name='$option'";
  $result = pg_exec($dbh,$query);
  $current_value=pg_result($result,0,"value");
  $tovalid=pg_result($result,0,"tovalid");
  if ($tovalid == "t") { $note="*"; }
  if ($current_value == $value) {
    return "<B><FONT COLOR=#00AA00 SIZE=+1>$link$note</FONT></B>&nbsp;&nbsp;";
  }
  else {
    return "<A HREF=options.php?action=change&option=$option&value=$value>$link</A>&nbsp;&nbsp;";
  }
}    
                      
function get_option($dbh,$option) { // returns the value of an option
  $query = "select value,tovalid,old_value from options where name='$option'";
  $result = pg_exec($dbh,$query);
  $current_value=pg_result($result,0,"value");
  $old_value=pg_result($result,0,"old_value");
  $tovalid=pg_result($result,0,"tovalid");
  if ($tovalid == "t") { return $old_value; }
  else { return $current_value; }
}

function set_option($dbh,$option,$value) { // sets an option into the options table
  $query = "select tovalid,value from options where name='$option'";
  $result = pg_exec($dbh,$query);
  $tovalid=pg_result($result,0,"tovalid");
  if ($tovalid == "t") {
    $oldvalue_update="";
  }
  else {
    $oldvalue_update=",old_value='". pg_result($result,0,"value") ."'";
  }
  $query = "update options set value='$value',tovalid='1' $oldvalue_update where name='$option'";
  $result = pg_exec($dbh,$query);
}      
                               
// added by olecam : return non zero if there is something to valid
function is_tovalid($dbh) 
{
        $query = "SELECT tovalid FROM options WHERE tovalid='1' LIMIT 1";
        $result = pg_exec($dbh, $query);
        return (pg_numrows($result) > 0 ) ? 1 : 0;
}

function validip($ip) { //returns 1 if $ip is a valid ip address else 0
  $ok = 1;
  if (!is_string($ip)) {
        $ok = 0;
  }
  $ip_long = ip2long($ip);
  $ip_revers = long2ip($ip_long);
  if ($ip != $ip_revers) {
        $ok = 0;
  }
return $ok;
}

function ipintranet($ipint) { //return 1 if $ipint is a valid intranet ip else 0

  require("../../slis.conf.php");
  $ok = 1;
  $ip_long = ip2long($ipint);
  $min = ip2long($INTRANET_NET);
  $max = (ip2long("255.255.255.255") - ip2long($INTRANET_MASK)) + ip2long($INTRANET_NET);

if (($ip_long <= $min) || ($ip_long >= $max)) {
        $ok = 0;
  }

return $ok;
}

function get_version() { //returns the version of the SLIS
  $version=file("/etc/version_slis_num");
  return $version[0];
}

?>
