<?
/*  $Id: search.inc.php,v 3.2 2003/03/26 13:46:48 bzizou Exp $
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

function get_groups_search_list($db,$search)  // return all groups, for include in dbl table, that match paterns $serach.
{
  require("../../slis.conf.php");
  require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
  $search = strtolower($search);
  $query = "select * from \"classes\" where lower(nom) like '%$search%';";
  $result = pg_exec($db, $query);
  $numrow = pg_numrows($result);
  $row_number = 0; //first rows
  $checkrown = $numrow ; // check for while
  while($row_number != $checkrown)
  {
      // extract infos
      $row = pg_fetch_row($result,$row_number);
      $classeid = StripSlashes($row[0]);
      $classe = StripSlashes($row[1]);

      /* check if user is delete */
      $isdel = is_common_delete($db,$classeid);

      /* new row */
      $row_number++;

      /* output */
      //trash
      $val .= "<li>\n";
      $val .= "<a href=\"edit.php?mod=del&id=$classeid\"><img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></a>&nbsp;\n"; // delete group
      $val .= "<a href=\"view.php?mode=allgroupusers&gid=$classeid\"><img src=\"../images/group.gif\" width=18 height=18 BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Users\" title=\"$lang_Users\"></a>&nbsp;\n"; // users of group
      // classe name
      $val .= "<a href=edit.php?mod=classe&update=yes&classeid=$classeid><font color=\"#0000FF\">";
      if($isdel == "1")
      {
          $val .= "<s>";
      }
      $val .= "$classe";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "</font></a>&nbsp;\n";
  }
  return($val);
}

function get_users_delete_list($db)  // return all users who will be deleted if validate, for include in dbl table.
{
  require("../../slis.conf.php");
  require("../inc/lang.inc.php"); // SLIS is multinational now
  $query = "select nom,prenom,login,id,infos,code from \"users\" where delete=true;";
  $result = pg_exec($db,$query);
  $numrow = pg_numrows($result);
  $row_number = 0; //first rows
  $checkrown = $numrow ; // check for while
  $val .= "$lang_delete_after.";
  while($row_number != $checkrown)
    {
      // extract infos
      $row = pg_fetch_row($result,$row_number);
      $nom = StripSlashes($row[0]);
      $prenom = StripSlashes($row[1]);
      $login = StripSlashes($row[2]);
      $userid = StripSlashes($row[3]);
      $userinfos = StripSlashes($row[4]);
      $code = StripSlashes($row[5]);

      /* change empty fields to html space carater */
      if (empty($nom))
      {
         $nom = "&nbsp;";
      }
      if (empty($prenom))
      {
         $prenom = "&nbsp;";
      }
      /* rewrite params */
      $userinfos = rewrite_params($userinfos);
      $code = rewrite_params($code);
      /* new row */
      $row_number++;
      /* check if user is delete */
      $isdel = is_common_delete($db,$userid);
      /* output */
      $val .= "<li>";
      if($isdel == "1") // make undelete link
      {
         $val .= "<a href=\"view.php?mode=undelindelusers&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/untrash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Undelete\" title=\"$lang_Undelete\"></a>&nbsp;&nbsp;\n"; // undelete user
      }
      else
      {
         $val .= "<a href=\"view.php?mode=delindelusers&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></a>&nbsp;&nbsp;\n"; // delete user
      }
      if($code)
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&code=".rewrite_params($code)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      else
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$nom";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$prenom</a></font></b>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;\n";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "<I>$login</I>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= " &nbsp;\n";
  }
  $val .= "<HR><center>$numrow $lang_Users</center>\n";
  if($numrow == 0)
    $val= "$lang_no_more_users. <BR> <a href=\"index.php\">$lang_back_users_menu\n";
  return($val);
}

function get_users_search_list($db,$search)  // return all users, for include in dbl table, that match paterns $serach.
{
  require("../../slis.conf.php");
  require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
  $search = strtolower($search);
  $query = "select nom,prenom,login,id,infos,code from \"users\" where lower(nom) like '%$search%' or lower(login) like '%$search%';";
  $result = pg_exec($db,$query);
  $numrow = pg_numrows($result);
  $row_number = 0; //first rows
  $checkrown = $numrow ; // check for while
  while($row_number != $checkrown)
  {
      // extract infos
      $row = pg_fetch_row($result,$row_number);
      $nom = StripSlashes($row[0]);
      $prenom = StripSlashes($row[1]);
      $login = StripSlashes($row[2]);
      $userid = StripSlashes($row[3]);
      $userinfos = StripSlashes($row[4]);
      $code = StripSlashes($row[5]);

      /* change empty fields to html space carater */
      if (empty($nom))
      {
         $nom = "&nbsp;";
      }
      if (empty($prenom))
      {
         $prenom = "&nbsp;";
      }
      /* new row */
      $row_number++;
      /* check if user is delete */
      $isdel = is_common_delete($db,$userid);
      /* output */
      $val .= "<li>";
      $val .= "<A NAME=\"user".$userid."\"></A>\n"; // make ancre
      if($isdel == "1") // make undelete link
      {
         $val .= "<a href=\"view.php?mode=undelinsearch&search=$search&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/untrash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Undelete\" title=\"$lang_Undelete\"></a>&nbsp;&nbsp;\n"; // undelete user
      }
      else
      {
         $val .= "<a href=\"view.php?mode=delinsearch&search=$search&id=$userid#user".$userid."\">";
         $val .= "<img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></a>&nbsp;&nbsp;\n"; // delete user
      }

      if($code)
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&code=".rewrite_params($code)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      else
      {
          $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
      }
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$nom";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "$prenom</a></font></b>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= "&nbsp;\n";
      if($isdel == "1")  // strick user in deleting before valid
      {
          $val .= "<s>";
      }
      $val .= "<I>$login</I>";
      if($isdel == "1")
      {
          $val .= "</s>";
      }
      $val .= " &nbsp;\n";
  }
  return($val);
}

function get_groups_users_list($db,$gid) // return all class users formated in html for include in dbltable
{
    require("../../slis.conf.php");
    require("../inc/lang/$LANGUAGE.inc.php"); // SLIS is multinational now
    $type = get_idtype($db,$gid);
    if($type == "classe")
    {
       $search = strtolower($search);
       $query = "select t1.nom,t1.prenom,t1.login,t1.id,t1.infos,t1.code from \"users\" AS t1, \"groups\" AS t2 where t2.classeid='$gid' AND t1.id=t2.userid;";
       $result = pg_exec($db,$query);
       $numrow = pg_numrows($result);
       $row_number = 0; //first rows
       $checkrown = $numrow ; // check for while
       $val = "<BR>";
       while($row_number != $checkrown)
       {
          // extract infos
          $row = pg_fetch_row($result,$row_number);
          $nom = StripSlashes($row[0]);
          $prenom = StripSlashes($row[1]);
          $login = StripSlashes($row[2]);
          $userid = StripSlashes($row[3]);
          $userinfos = StripSlashes($row[4]);
          $code = StripSlashes($row[5]);

          /* change empty fields to html space carater */
          if(empty($nom))
          {
              $nom = "&nbsp;";
          }
          if(empty($prenom))
          {
              $prenom = "&nbsp;";
          }
          /* new row */
          $row_number++;
          /* check if user is delete */
          $isdel = is_common_delete($db,$userid);
          /* output */
          $val .= "<li>";
          $val .= "<a href=\"edit.php?mod=del&id=$userid\"><img src=\"../images/trash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete\" title=\"$lang_Delete\"></a>&nbsp;&nbsp;\n"; // delete user
          if($code)
          {
              $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&code=".rewrite_params($code)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
          }
          else
          {
              $val .= "<b><a href=edit.php?mod=user&update=yes&Nom=".rewrite_params($nom)."&Prenom=".rewrite_params($prenom)."&userid=".rewrite_params($userid)."&infos=".rewrite_params($userinfos)."><font color=\"#0000FF\">";
          }
          if($isdel == "1")  // strick user in deleting before valid
          {
             $val .= "<s>";
          }
          $val .= "$nom";
          if($isdel == "1")
          {
              $val .= "</s>";
          }
          $val .= "&nbsp;";
          if($isdel == "1")  // strick user in deleting before valid
          {
              $val .= "<s>";
          }
          $val .= "$prenom</a></font></b>";
          if($isdel == "1")
          {
              $val .= "</s>";
          }
          $val .= "&nbsp;\n";
          if($isdel == "1")  // strick user in deleting before valid
          {
              $val .= "<s>";
          }
          $val .= "<I>$login</I>";
          if($isdel == "1")
          {
              $val .= "</s>";
          }
          $val .= " &nbsp;\n";
      }


     /* New line for deleting all user */
     $group_name = get_name($db,$gid);
     $val .= "<hr width=\"10%\" align=\"center\"><center>";
     $val .= "<li><a href=\"edit.php?mod=del&special=allgusers&id=$gid\"><img src=\"../images/redtrash.gif\" BORDER=\"0\" ALIGN=\"absmiddle\" alt=\"$lang_Delete $lang_All_users_of_group $group_name\" title=\"$lang_Delete $lang_All_users_of_group $group_name\"></a>&nbsp;&nbsp;$lang_All_users_of_group <b>$group_name</b></center>\n"; // delete all group users


     // add new link with redtrash for erase all users of a groups.
     $val .= "<HR><center>$numrow $lang_Users</center>\n";
    }
    else  // we d'ont have groups id
    {
          $val = errormsg("$lang_One_error_append<br>search.inc.php l:224");
    }
    return($val);
}

function del_all_users_of_group($db,$gid)  // marks all users of groups id 'gid' in state ' to delete ' and return 0 if ok or error msg.
{
   $type = get_idtype($db,$gid);
   if($type == "classe")
   {
       $query = "select t1.id from \"users\" AS t1, \"groups\" AS t2 where t2.classeid='$gid' AND t1.id=t2.userid;";
       $result = pg_exec($db,$query);
       $numrow = pg_numrows($result);
       $row_number = 0; //first rows
       $checkrown = $numrow ; // check for while
       $val = "<BR>";
       while($row_number != $checkrown)
       {
          // extract infos
          $row = pg_fetch_row($result,$row_number);
          $id = StripSlashes($row[0]);

          // delete user
          delete_common($db,$id);
          $row_number++;
       }
       $val = "0";
   }
   else
   {
        $val = errormsg("$lang_One_error_append<br>search.inc.php l:261");
        slislog(warning,"can't delete all userid of group ' $gid ' in function del_all_users_of_group of inc/search.inc.php");
   }
   return($val);
}

?>
