<?
/*
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

// loading libs
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/pgsql.inc.php");
require("../inc/themes.inc.php"); // output themes

// loading html elements
$starthtml = startHTML("$lang_admin_users");
$end = endHTML();
//print html page en f(x) du contexte
//debut commun
print "$starthtml\n";

// If admin is not configured, stop and ask for the config
stop_if_no_admin();

// check mode.
if($mode)
{
   $db = dbconnect();
   if($mode == "view")  // VIEW ACCOUNTS AND CLASS
   {
      $contenu .= "<BR><B><FONT FACE=\"Helvetica,Arial\"><UL>";
      $contenu .= "<LI><A HREF=\"./view.php?mode=searchgroups\">$lang_Groups</A><BR>\n";
      $contenu .= "<LI><A HREF=\"./view.php?mode=searchusers\">$lang_Users</A><BR>\n";
      $contenu .= "</UL></FONT></B><BR>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Modif_view,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
   }

   elseif($mode == "classe")  // CREATE CLASS
   {
      $contenu = "<p><FORM action=\"./add.php?mod=classe\" method=\"POST\">\n";
      $contenu .= "<CENTER><TABLE BORDER=\"0\">\n";
      $contenu .= "<TR>\n";
      $contenu .= "<TD><B>$lang_Name :</B></TD>\n";
      $contenu .= "<TD><INPUT TYPE=\"text\" NAME=\"class\" VALUE=\"$class\" SIZE=20></TD>\n</TR>\n";
      $contenu .= "</TABLE>\n<P>\n<CENTER>\n<P>\n";
      $contenu .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"OK\">\n<input type=\"reset\" value=\"$lang_cancel\">\n<P>\n</CENTER>\n";
      $contenu .= "</FORM>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Creating_Group,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
   }

   elseif($mode == "mmanu")  // CREATE USERS
   {
      $type = 2; // do function classe_list to return a select.
      $classe_select = get_classe_list($db,$type);
      $contenu .= "<p><FORM action=\"./add.php?mod=mmanu\" method=\"POST\">\n";
      $contenu .= "<CENTER>\n<TABLE ALIGN=CENTER BORDER=\"0\">\n<TR><TD>\n<TABLE ALIGN=CENTER BORDER=\"0\">\n<TR>\n";
      $contenu .= "<TD><B>$lang_Name :</B></TD>\n";
      $contenu .= "<TD><INPUT TYPE=\"text\" NAME=\"Nom\" VALUE=\"$Nom\" SIZE=20></TD></TR>\n<TR>\n";
      $contenu .= "<TD><B>$lang_Surename :</B></TD>\n";
      $contenu .= "<TD><INPUT TYPE=\"text\" NAME=\"Prenom\" VALUE=\"$Prenom\" SIZE=20></TD>\n</TR>\n";
      $contenu .= "<TD><B>$lang_Student_code :</B></TD>\n";
      $contenu .= "<TD><INPUT TYPE=\"text\" NAME=\"code\" VALUE=\"$code\" SIZE=20></TD>\n</TR>\n";
      $contenu .= "<TD><B>$lang_Primary_group :</B></TD>\n";
      $contenu .= "<TD>$classe_select</TD>\n</TR>\n";
      $contenu .= "<TR>\n";
      $contenu .= "<TD><B>$lang_all_kind_of_infos :</B></TD>\n";
      $contenu .= "<TD><INPUT TYPE=\"text\" NAME=\"infos\" VALUE=\"$infos\" SIZE=20></TD>\n</TR>\n";
      $contenu .= "</TABLE>\n</TR></TD>\n</TABLE>\n</CENTER>\n<P>\n<CENTER>\n<P>\n";
      $contenu .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"OK\">\n<input type=\"reset\" value=\"$lang_cancel\">\n<P>\n</CENTER>\n</FONT></FORM>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_add_users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
      }
   elseif($mode == "alias") // CREATE ALIAS
   {
       $select_aliasid = select_alias_id($db);
       $contenu .= "<P><FORM action=\"./add.php?mod=alias\" method=\"POST\">\n";
       $contenu .= "<CENTER>\n<TABLE ALIGN=CENTER BORDER=\"0\">\n<TR><TD>\n<TABLE ALIGN=CENTER BORDER=\"0\">\n";
       $contenu .= "<TR>\n";
       $contenu .= "<TD><B>$lang_Login_or_class :</B></TD>\n";
       $contenu .= "<TD>$select_aliasid\n";
       $contenu .= "</TD></TR></TABLE>\n<TR>\n";
       $contenu .= "<TD><B>&nbsp; &nbsp;$lang_Alias : </B>&nbsp; &nbsp;\n";
       $contenu .= "<INPUT TYPE=\"text\" NAME=\"alias\" VALUE=\"$alias\" SIZE=20></TD>\n</TR>\n";
       $contenu .= "</TABLE>\n</CENTER>\n<P>\n";
       $contenu .= center("<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"OK\">\n<input type=\"reset\" value=\"$lang_cancel\">\n<P>\n</FORM>\n");
       $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_addalias,$titre_color);
       $val = center($val);
       $val = saut(2)."$val";
       print "$val\n";
   }
    elseif($mode == "multi") // MULTIGROUP
   {
       $select_user = select_users($db);
       $select_classe = select_classe($db);
       $contenu .= "<FORM action=\"./add.php?mod=multi\" method=\"POST\">\n";
       $contenu .= "<CENTER>\n";
       $contenu .= "<TABLE ALIGN=CENTER BORDER=\"0\">\n";
       $contenu .= "<TR align=\"center\">\n";
       $contenu .= "<TD><B>$lang_User :</B></TD>\n";
       $contenu .= "<TD>$select_user\n";
       $contenu .= "<TR align=\"center\">\n";
       $contenu .="<TD><B>$lang_Group :</B></TD>\n";
       $contenu .="<TD>$select_classe\n";
       $contenu .= "<TR></TABLE></CENTER>\n";
       $contenu .="<CENTER><INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"OK\">\n<P>\n</CENTER>\n</FONT></FORM>\n";
       $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_affectation_multigroup,$titre_color);
       $val = center($val);
       $val = saut(2)."$val";
       print "$val\n";
   }
   elseif($mode == "gep") // IMPORT.
   {
      $contenu .= "<p><form action=import.php method=post>\n";
      $contenu .= "<TABLE width=\"100%\" border=\"0\"><tr>\n<td align=right nowrap>\n";
      $contenu .= "$lang_First $lang_field: ".users_fields_select("first")."<br>\n";
      $contenu .= "$lang_Second $lang_field: ".users_fields_select("second")."<br>\n";
      $contenu .= "$lang_Third $lang_field: ".users_fields_select("third")."<br>\n";
      $contenu .= "$lang_For $lang_field: ".users_fields_select("for")."<br>\n";
      $contenu .= "$lang_Five $lang_field: ".users_fields_select("five")."<br>\n";
      $contenu .= "$lang_Six $lang_field: ".users_fields_select("six")."<br>\n";
      $contenu .= "</td><td align=center>\n";
      $contenu .= "$lang_Separator : <textarea name=separator ROWS=1 COLS=5 value=$separator></textarea>\n";
      $contenu .= "</td><td align=\"center\"><FONT FACE=Helvetica,Arial>$lang_import_help</font><P>\n";
      $contenu .= "<textarea name=texte ROWS=10 COLS=40 value=$texte></textarea>&nbsp;\n";
      $contenu .= "<TR>\n";
      $contenu .= center("<td COLSPAN=\"3\" align=\"center\"><input type=submit value=$lang_Import></td>\n");
      $contenu .= "</TABLE>\n";
      $contenu = center($contenu);
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_addcompte_import,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
   }
   elseif($mode == "groupimp") // IMPORT GROUP.
   {
      $contenu .= "<p><form name=\"groupimp\" action=importg.php method=post>\n";
      $contenu .= "<TABLE width=\"100%\" border=\"0\"><tr>\n<td align=right nowrap>\n";
      $contenu .= "$lang_First $lang_field: ".group_fields_select("group1")."<br>\n";
      $contenu .= "$lang_Second $lang_field: ".group_fields_select("group2")."<br>\n";
      $contenu .= "</td><td align=center>\n";
      $contenu .= "$lang_Separator : <textarea name=separatorg ROWS=1 COLS=5 value=$separator></textarea>\n";
      $contenu .= "</td><td align=\"center\"><FONT FACE=Helvetica,Arial>$lang_import_help</font><P>\n";
      $contenu .= "<textarea name=texteg ROWS=10 COLS=40 value=$texte></textarea>&nbsp;\n";
      $contenu .= "<TR>\n";
      $contenu .= center("<td><input type=checkbox name=checkbox>$lang_remove_before ?</td><td COLSPAN=\"2\" align=\"center\"><input type=submit value=$lang_Import></td>\n");
      $contenu .= "</TABLE>\n";
      $contenu = center($contenu);
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Groups_Importing,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
   }
   else
   {
      print errormsg("$lang_badparams_submit\n");
      slislog(error," miss or bad params in users/index.php : $QUERY_STRING from $HTTP_REFERER");
   }
   // close db
   pg_close($db);
}
else  // default menu.
{
   $contenu =  "<BR><FONT FACE=Helvetica,Arial>\n<B>\n<UL>\n<LI><FONT SIZE=+1>$lang_Creating:</FONT>\n";
   $contenu .= "<UL>\n";
   $contenu .= "<LI><A HREF=\"./?mode=classe\">$lang_Groups</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./?mode=mmanu\">$lang_Users</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./?mode=gep\">$lang_Users_Importing</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./?mode=alias\">$lang_Alias</A>\n";
   $contenu .= "</UL>\n<P>\n";
   $contenu .= "<LI><FONT SIZE=+1>$lang_Editing:</FONT>\n";
   $contenu .= "<UL>\n";
   $contenu .= "<LI><A HREF=\"./view.php?mode=searchgroups\">$lang_Groups</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./view.php?mode=searchusers\">$lang_Users</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./?mode=multi\">$lang_Users_Affiliation</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./?mode=groupimp\">$lang_Users_Affiliation (Import)</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./view.php?mode=delaffconfirm\">$lang_delete_affil</A><BR>\n";
   $contenu .= "<LI><A HREF=\"./view.php?mode=delallconfirm\">$lang_delete_all</A><BR>\n";
   $contenu .= "</UL>\n</B>\n<p>&nbsp;</FONT>\n";
   $val = newsdbtbl("60%",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_manage_user,$titre_color);
   $val = center($val);
   $val = saut(2)."$val";
   print "$val\n";
}

//fin de page commune
print "$end\n";

?>
