<?PHP
/* $Id: services.php,v 3.1 2003/03/20 11:26:37 bzizou Exp $

Control pannel for services

This script is part of the SLIS Project initiated by the CARMI-Internet
(Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
(Acadmie de Grenoble - France 38).

This script have been writen by Bruno Bzeznik - copyright (C) 2001
Ce script  t crit par Bruno Bzeznik - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire.
Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License
along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail
to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  <slis@ac-grenoble.fr>
*/

// loading libs and init
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
print startHTML("Services control pannel");
$gif_on="../images/ledgreen.gif";
$gif_off="../images/ledred.gif";
if ($FETCHMAIL == "") {
  exec("$SLIS_BINDIR/get_setup_option FETCHMAIL",$D);
  $FETCHMAIL=$D[0];
}
if ($CYBERECOLE == "1" || $CYBERSCHOOL == "1" || $SMBCONF =="1") {
  $SMBVIEW="1";
}

// RESTARTING OF A SERVICE
if ($action=="restart") {

  // Create the script for restarting
  $file = fopen("$QUEUE/services_startup","w+");
  $var="/etc/rc.d/init.d/$service restart\n";
  fwrite($file,"$var\n");

  // Touch the "to be processed file"
  touch("$QUEUE/tbp");

  // Prepare the message
  $text = "<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<CENTER>$lang_services_Restart $service $lang_services_Sent <BR><BR><P>";
  $text .= "</CENTER>";
  $text .= "<DIV ALIGN=RIGHT><A HREF=./services.php>&lt;&lt;</A>\n";
}


// THE SYSV INIT SCRIPTS MODIF
elseif ($action=="valid") {

  // Create the script modifying init scripts
  $file = fopen("$QUEUE/services_startup","w+");
  $var="";
  if ($mail=="1") { $var .= "chkconfig --add sendmail\nchkconfig sendmail on\n"; }
  else { $var .= "chkconfig --add sendmail\nchkconfig sendmail off\n/etc/rc.d/init.d/sendmail stop\n"; }
  if ($http=="1") { $var .= "chkconfig --add httpd\nchkconfig httpd on\n"; }
  else { $var .= "chkconfig --add httpd\nchkconfig httpd off\n/etc/rc.d/init.d/httpd stop\n"; }
  if ($dhcp=="1") { $var .= "chkconfig --add dhcpd\nchkconfig dhcpd on\n"; }
  else { $var .= "chkconfig --add dhcpd\nchkconfig dhcpd off\n/etc/rc.d/init.d/dhcpd stop\n"; }
  if ($proxy=="1") { $var .= "chkconfig --add runcache\nchkconfig runcache on\n"; }
  else { $var .= "chkconfig --add runcache\nchkconfig runcache off\n/etc/rc.d/init.d/runcache stop\n"; }
  if ($ldap=="1") { $var .= "chkconfig --add ldap\nchkconfig ldap on\n"; }
  else { $var .= "chkconfig --add ldap\nchkconfig ldap off\n/etc/rc.d/init.d/ldap stop\n"; }
  if ($smb=="1") { $var .= "chkconfig --add smb\nchkconfig smb on\n"; }
  else { $var .= "chkconfig --add smb\nchkconfig smb off\n/etc/rc.d/init.d/smb stop\n"; }
  if ($fetchmail=="1") { $var .= "chkconfig --add fetchmail\nchkconfig fetchmail on\n"; }
  else { $var .= "chkconfig --add fetchmail\nchkconfig fetchmail off\n/etc/rc.d/init.d/fetchmail stop\n"; }

  //Ajout de Postgres
  if ($pgsql=="1") { $var .= "chkconfig --add postgresql\nchkconfig postgresql on\n"; }
  else { $var .= "chkconfig --add postgresql\nchkconfig postgresql off\n/etc/rc.d/init.d/postgresql stop\n"; }


  fwrite($file,"$var\n");

  // Touch the "to be processed file"
  touch("$QUEUE/tbp");

  // Write a message telling this is done
  $text = "<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<CENTER> $lang_services_Startup_done <BR><BR><P>";
  $text .= "</CENTER>";
  $text .= "<DIV ALIGN=RIGHT><A HREF=./services.php>&lt;&lt;</A>\n";
}


// THE PANEL
else {

  // Collect the status of each service
  // Do a ps
  exec("/bin/ps awux",$ps);

  // Status
  if (array_values(preg_grep("/sendmail/",$ps))) { $gif_mail=$gif_on; $status_mail="on"; }
  else { $gif_mail=$gif_off; $status_mail="off"; }
  if (array_values(preg_grep("/slapd/",$ps))) { $gif_ldap=$gif_on; $status_ldap="on"; }
  else { $gif_ldap=$gif_off; $status_ldap="off"; }
  if (array_values(preg_grep("/dhcpd/",$ps))) { $gif_dhcp=$gif_on; $status_dhcp="on"; }
  else { $gif_dhcp=$gif_off; $status_dhcp="off"; }
  if (array_values(preg_grep("/squid/",$ps))) { $gif_proxy=$gif_on; $status_proxy="on"; }
  else { $gif_proxy=$gif_off; $status_proxy="off"; }
  if (array_values(preg_grep("/smbd/",$ps))) { $gif_smb=$gif_on; $status_smb="on"; }
  else { $gif_smb=$gif_off; $status_smb="off"; }
  if (array_values(preg_grep("/nobody.*httpd/",$ps))) { $gif_http=$gif_on; $status_http="on"; }
  else { $gif_http=$gif_off; $status_http="off"; }
  if (array_values(preg_grep("/fetchmail/",$ps))) { $gif_fetchmail=$gif_on; $status_fetchmail="on"; }
  else { $gif_fetchmail=$gif_off; $status_fetchmail="off"; }

  //Ajout de Postgres
  if(array_values(preg_grep("/postgres/",$ps))) { $gif_pgsql=$gif_on; $status_pgsql="on"; }
  else { $gif_pgsql=$gif_off; $status_pgsql="off"; }

 
  // Startup status
  putenv("LANG=C");
  exec("/sbin/chkconfig --list",$chkconfig);
  if (array_values(preg_grep("/^sendmail.*3:((on)|(Marche))/",$chkconfig))) { $checked_mail="checked"; }
  else { $checked_mail=""; }
  if (array_values(preg_grep("/^ldap.*3:((on)|(Marche))/",$chkconfig))) { $checked_ldap="checked"; }
  else { $checked_ldap=""; }
  if (array_values(preg_grep("/^dhcpd.*3:((on)|(Marche))/",$chkconfig))) { $checked_dhcp="checked"; }
  else { $checked_dhcp=""; }
  if (array_values(preg_grep("/^httpd.*3:((on)|(Marche))/",$chkconfig))) { $checked_http="checked"; }
  else { $checked_http=""; }
  if (array_values(preg_grep("/^runcache.*3:((on)|(Marche))/",$chkconfig))) { $checked_proxy="checked"; }
  else { $checked_proxy=""; }
  if (array_values(preg_grep("/^smb.*3:((on)|(Marche))/",$chkconfig))) { $checked_smb="checked"; }
  else { $checked_smb=""; }
  if (array_values(preg_grep("/^fetchmail.*3:((on)|(Marche))/",$chkconfig))) { $checked_fetchmail="checked"; }
  else { $checked_fetchmail=""; }

  //Ajout de Postgres
  if (array_values(preg_grep("/^postgresql.*3:((on)|(Marche))/",$chkconfig))) { $checked_pgsql="checked"; }
  else { $checked_pgsql=""; }


  $text .= "<BR><FONT FACE=Helvetica,Arial>\n";
  $text .= "<FORM ACTION=./services.php METHOD=post>\n";
  $text .= "<INPUT TYPE=hidden NAME=action VALUE=valid>\n";
  $text .= "<TABLE BORDER=0>\n";
  $text .= "<TR>\n";
  $text .= "<TD>&nbsp;</TD>\n";
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>MAIL&nbsp;</FONT></B></TD>\n";
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>HTTP&nbsp;</FONT></B></TD>\n";
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>LDAP&nbsp;</FONT></B></TD>\n";
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>DHCP&nbsp;</FONT></B></TD>\n";
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>PROXY</FONT></B></TD>\n";
  if ($SMBVIEW == "1") {
    $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>&nbsp;SMB&nbsp;</FONT></B></TD>\n";
  }
  if ($FETCHMAIL == "1") {
    $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>FETCHMAIL</FONT></B></TD>\n";
  }

  //Ajout de Postgres
  $text .= "<TD><B><FONT FACE=HELVETICA,ARIAL>PGSQL</FONT></B></TD>\n";


  $text .= "</TR>\n";
  $text .= "<TR>\n";
  $text .= "<TD><FONT FACE=HELVETICA,ARIAL><B>$lang_services_State</B></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"Mail server is $status_mail\" SRC=$gif_mail></TD>\n";
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"Apache server is $status_http\" SRC=$gif_http></TD>\n";
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"LDAP server is $status_ldap\" SRC=$gif_ldap></TD>\n";
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"DHCP server is $status_dhcp\" SRC=$gif_dhcp></TD>\n";
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"Proxy-cache is $status_proxy\" SRC=$gif_proxy></TD>\n";
  if ($SMBVIEW == "1") {
    $text .= "<TD ALIGN=CENTER><IMG ALT=\"Samba server (netbios) is $status_smb\" SRC=$gif_smb></TD>\n";
  }
  if ($FETCHMAIL == "1") {
    $text .= "<TD ALIGN=CENTER><IMG ALT=\"Fetchmail is $status_fetchmail\" SRC=$gif_fetchmail></TD>\n";
  }

  //Ajout de Postgres
  $text .= "<TD ALIGN=CENTER><IMG ALT=\"Pgsql is $status_pgsql\" SRC=$gif_pgsql></TD>\n";


  $text .= "</TR>\n";
  $text .= "<TR>\n";
  $text .= "<TD><FONT FACE=HELVETICA,ARIAL><B>$lang_services_Startup</B></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"mail\" VALUE=\"1\" $checked_mail></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"http\" VALUE=\"1\" $checked_http></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"ldap\" VALUE=\"1\" $checked_ldap></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"dhcp\" VALUE=\"1\" $checked_dhcp></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"proxy\" VALUE=\"1\" $checked_proxy></FONT></TD>\n";
  if ($SMBVIEW == "1") {
    $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"smb\" VALUE=\"1\" $checked_smb></FONT></TD>\n";
  }
  if ($FETCHMAIL == "1") {
    $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"fetchmail\" VALUE=\"1\" $checked_fetchmail></FONT></TD>\n";
  }

  //Ajout de Postgres
  $text .= "<TD ALIGN=CENTER><FONT FACE=HELVETICA,ARIAL><INPUT TYPE=\"checkbox\" NAME=\"pgsql\" VALUE=\"1\" $checked_pgsql></FONT></TD>\n";


  $text .= "</TR>\n";
  $text .= "<TR>\n";
  $text .= "<TD><FONT FACE=HELVETICA,ARIAL><B>$lang_services_Restart_cmd</B></FONT></TD>\n";
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=sendmail><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd MAIL\" SRC=../images/restart.gif></A></TD>\n";
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=httpd><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd HTTP\" SRC=../images/restart.gif></A></TD>\n";
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=ldap><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd LDAP\" SRC=../images/restart.gif></A></TD>\n";
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=dhcpd><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd DHCP\" SRC=../images/restart.gif></A></TD>\n";
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=runcache><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd PROXY\" SRC=../images/restart.gif></A></TD>\n";
  if ($SMBVIEW == "1") {
    $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=smb><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd SMB\" SRC=../images/restart.gif></A></TD>\n";
  }
  if ($FETCHMAIL == "1") {
    $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=fetchmail><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd FETCHMAIL\" SRC=../images/restart.gif></A></TD>\n";
  }

  //Ajout de Postgres
  $text .= "<TD ALIGN=CENTER><A HREF=./services.php?action=restart&service=postgresql><IMG BORDER=0 ALT=\"$lang_services_Restart_cmd PGSQL\" SRC=../images/restart.gif></A></TD>\n";


  $text .= "</TR>\n";
  $text .= "</TABLE>\n";
  $text .= "<CENTER><HR><INPUT TYPE=submit VALUE=OK></CENTER></FORM>\n";
  $text .= "</FONT><P>";
}

// print the message
$val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$text,$border,$lang_services_Title,$titre_color);
$val = center($val);
$val = saut(2)."$val";
print "$val\n";        

// The end
print endHTML();

?>
