<?
/*  $id: $
This script is part of the SLIS Project initiated by the CARMI-Internet (Acadmie de Grenoble - France 38).
Ce script fait partie du projet SLIS dmarr par le CARMI-Internet (Acadmie de Grenoble - France 38).

This script have been write by Julien Dumont - copyright (C) 2001
Ce script  t crit par Julien Dumont - copyright (C) - 2001

SLIS : Serveur de communications Linux pour l'Internet Scolaire. Copyright (C) 1998-2001 Bruno Bzeznik

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details. You should have received a copy of the GNU General Public License along with this program (For example ./COPYING);
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please send all comments and bug reports by electronic mail to: <slis@ac-grenoble.fr>
Envoyez vos suggestions et reports de bugs par e-mail  Bruno Bzeznik <slis@ac-grenoble.fr>
*/

// tools and libs
require("../inc/pgsql.inc.php");
require("../inc/html.inc.php");
require("../inc/lib.inc.php");
require("../inc/search.inc.php");

// connection sql
$db = dbconnect();

//loading html part
$starthtml = startHTML("Administration des utilisateurs");
$end = endHTML();

// search mode
if($mode == "search")
{
    if($type == "groups")
    {
        if( (!($search)) || ($search == "*") )
        {
            pg_close($db);
            header("Location: view.php?mode=allgroups"); /* Redirect browser allgroups display */
            exit;
        }
        else
        {
            print $starthtml;
            $classedata = get_groups_search_list($db,$search); /* search include give result in text */
            $contenu .= "<P>\n";
            $contenu .= "$classedata<br>\n";
            $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Groups,$titre_color);
            $val = center($val);
            $val = saut(2)."$val";
            print "$val\n";
            print $end;
            exit;
        }
    }
    elseif($type == "users")
    {
        if( (!($search)) || ($search == "*") )
        {
            pg_close($db);
            header("Location: view.php?mode=allusers"); /* Redirect browser allusers display */
            exit;
        }
        else
        {
            print $starthtml;
            $usersdata = get_users_search_list($db,$search); /* search include give result in text */
	    $search = strtolower($search);
	    $query = "select id from \"users\" where lower(nom) like '%$search%' or lower(login) like '%$search%';";
	    $result = pg_exec($db,$query);	
	    $numrow = pg_numrows($result);
	    $row_number = 0; //first rows
     	    $checkrown = $numrow ; // check for while
	    while($row_number != $checkrown)
	    {
	        // extract infos
	        $row = pg_fetch_row($result,$row_number);
	        if(!isset($liste))
			$liste = StripSlashes($row[0]);
		else
			$liste.=",".StripSlashes($row[0]);

	        /* new row */
	        $row_number++;
	        /* check if user is delete */
	        $isdel = is_common_delete($db,$userid);
            }

            $contenu .= "$usersdata<br>&nbsp;<br>\n";
	    $contenu .= "<li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
            $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
            $val = center($val);
            $val = saut(2)."$val";
            print "$val\n";
            print $end;
            exit;
        }
    }
}

//html header output
print $starthtml;

if($mode == "searchgroups")  // SERACHING SOME GROUPS
{
      $contenutmp .= "<FORM ACTION=view.php>\n";
      $contenutmp .= "&nbsp; $lang_Name : &nbsp; <INPUT TYPE=\"text\" name=\"search\" value=\"$search\">&nbsp; <BR>\n";
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"type\" value=\"groups\">\n"; // for know what kind of search it is.
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"mode\" value=\"search\">\n";
      $contenutmp .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"$lang_Search\">\n<input type=\"reset\" value=\"$lang_Reset\"></FORM>\n";
      $contenu .= "<P>\n";
      $contenu .= center($contenutmp);
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_groups_search,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "searchusers")  // SERACHING SOME USERS
{
      $contenutmp .= "<FORM ACTION=view.php>\n";
      $contenutmp .= "&nbsp; $lang_Name : &nbsp; <INPUT TYPE=\"text\" name=\"search\" value=\"$search\">&nbsp; <BR>\n";
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"type\" value=\"users\">\n"; // for know what kind of search it is.
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"mode\" value=\"search\">\n";
      $contenutmp .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"$lang_Search\">\n<input type=\"reset\" value=\"$lang_Reset\"></FORM>\n";
      $contenutmp .= "<FORM ACTION=view.php>\n";
      $contenutmp .= "<hr>&nbsp; $lang_Group : &nbsp; ".get_classe_list($db,"2")."&nbsp;<br>\n";
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"mode\" value=\"allgroupusers\">\n";
      $contenutmp .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"$lang_Search\"></FORM>\n";
      $contenutmp .= "<FORM ACTION=view.php>\n";
      $contenutmp .= "<hr><INPUT TYPE=\"hidden\" name=\"search\" value=\"\">&nbsp; <BR>\n";
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"type\" value=\"users\">\n"; // for know what kind of search it is.
      $contenutmp .= "<INPUT TYPE=\"hidden\" name=\"mode\" value=\"search\">\n";
      $contenutmp .= "<INPUT TYPE=\"submit\" NAME=\"name\" VALUE=\"$lang_Search_all\">\n</FORM>\n";
      $contenu .= "<br>\n";
      $contenu .= center($contenutmp);
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_users_search,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "allgroups")  // VIEW ALL GROUPS
{
      $type = 3; // do function classe_list to return a text values.
      $classedata = get_classe_list($db,$type);
      $contenu .= "<P>\n";
      $contenu .= "$classedata<br>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Groups,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "undelinallusers") // VIEW ALL USERS AFTER UNDELETING ONE
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = undelete_common($db,$id); // deleting
      }
      $usersdata = get_user_list($db);
      $query = "select id from \"users\";";
      $result = pg_exec($db,$query);
      $numrow = pg_numrows($result);
      $row_number = 0; //first rows
      $checkrown = $numrow ; // check for while
      while($row_number != $checkrown)
      {
           // extract infos
           $row = pg_fetch_row($result,$row_number);
           if(!isset($liste))
                   $liste = StripSlashes($row[0]);
           else
                   $liste.=",".StripSlashes($row[0]);
           /* new row */
           $row_number++;
           /* check if user is delete */
           $isdel = is_common_delete($db,$userid);
       }
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $contenu .= "<li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "delinallusers") // VIEW ALL USERS AFTER DELETING ONE
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = delete_common($db,$id); // deleting
      }
      $usersdata = get_user_list($db);
      $query = "select id from \"users\";";
      $result = pg_exec($db,$query);
      $numrow = pg_numrows($result);
      $row_number = 0; //first rows
      $checkrown = $numrow ; // check for while
      while($row_number != $checkrown)
      {
           // extract infos
           $row = pg_fetch_row($result,$row_number);
           if(!isset($liste))
                   $liste = StripSlashes($row[0]);
           else
                   $liste.=",".StripSlashes($row[0]);
           /* new row */
           $row_number++;
           /* check if user is delete */
           $isdel = is_common_delete($db,$userid);
       }
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $contenu .= "<li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "undelinsearch") // VIEW ALL USERS IN DELETING PROCESS AFTER UNDELETING ONE (IN SEARCH)
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = undelete_common($db,$id); // deleting
      }
      $usersdata = get_users_search_list($db,$search);
      $search = strtolower($search);
      $query = "select id from \"users\" where lower(nom) like '%$search%' or lower(login) like '%$search%';";
      $result = pg_exec($db,$query);
      $numrow = pg_numrows($result);
      $row_number = 0; //first rows
      $checkrown = $numrow ; // check for while
      while($row_number != $checkrown)
      {
           // extract infos
           $row = pg_fetch_row($result,$row_number);
           if(!isset($liste))
                   $liste = StripSlashes($row[0]);
           else
                   $liste.=",".StripSlashes($row[0]);
           /* new row */
           $row_number++;
           /* check if user is delete */
           $isdel = is_common_delete($db,$userid);
       }
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $contenu .= "<BR><li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "delinsearch") // VIEW ALL USERS IN DELETING PROCESS AFTER DELETING ONE (IN SEARCH)
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = delete_common($db,$id); // deleting
      }
      $usersdata = get_users_search_list($db,$search);
      $search = strtolower($search);
      $query = "select id from \"users\" where lower(nom) like '%$search%' or lower(login) like '%$search%';";
      $result = pg_exec($db,$query);
      $numrow = pg_numrows($result);
      $row_number = 0; //first rows
      $checkrown = $numrow ; // check for while
      while($row_number != $checkrown)
      {
           // extract infos
           $row = pg_fetch_row($result,$row_number);
           if(!isset($liste))
                   $liste = StripSlashes($row[0]);
           else
                   $liste.=",".StripSlashes($row[0]);
           /* new row */
           $row_number++;
           /* check if user is delete */
           $isdel = is_common_delete($db,$userid);
       }
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $contenu .= "<BR><li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "undelindelusers") // VIEW ALL USERS IN DELETING PROCESS AFTER UNDELETING ONE
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = undelete_common($db,$id); // deleting
      }
      $usersdata = get_users_delete_list($db);
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "delindelusers") // VIEW ALL USERS IN DELETING PROCESS AFTER DELETING ONE
{
      $type  = get_idtype($db,$id);
      if($type == "users")   // it's a user's id.
      {
         $check = delete_common($db,$id); // deleting
      }
      $usersdata = get_users_delete_list($db);
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "allusers")  // VIEW ALL USERS
{
      $usersdata = get_user_list($db);
      $query = "select id from \"users\";";
      $result = pg_exec($db,$query);
      $numrow = pg_numrows($result);
      $row_number = 0; //first rows
      $checkrown = $numrow ; // check for while
      while($row_number != $checkrown)
      {
           // extract infos
           $row = pg_fetch_row($result,$row_number);
           if(!isset($liste))
                   $liste = StripSlashes($row[0]);
           else
                   $liste.=",".StripSlashes($row[0]);
           /* new row */
           $row_number++;
           /* check if user is delete */
           $isdel = is_common_delete($db,$userid);
       }
      $contenu .= "<P>\n";
      $contenu .= "$usersdata<br>\n";
      $contenu .= "<li><a href=\"edit.php?mod=delsearch&id=$liste\"><img border=0 src='../images/redtrash.gif'></a>&nbsp;&nbsp;$lang_delete_those";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode == "allgroupusers") // VIEW ALL USER OF A GROUP
{
      if($class)
      {
          $gid = $class;
      }
      $groupname = get_name($db,$gid);
      $usersdata = get_groups_users_list($db,$gid);
      $contenu .= "$usersdata<br>\n";
      $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,"$lang_Users $lang_of $groupname",$titre_color);
      $val = center($val);
      $val = saut(2)."$val";
      print "$val\n";
}
elseif($mode=="delallconfirm")
{
	$contenu = "<BR>&nbsp;$lang_users_confirm&nbsp;";
	$contenu .= center(saut(1)."<a href=\"edit.php?mod=delall\">$lang_users_yes</a> &nbsp;&nbsp;&nbsp;&nbsp; <a href=\"index.php\">$lang_users_no</a>");
	$val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
	$val = center($val);
	$val = saut(2)."$val";
	print "$val\n";
}
elseif($mode=="delaffconfirm")
{
        $contenu = "<BR>&nbsp;$lang_users_confirm2&nbsp;";
        $contenu .= center(saut(1)."<a href=\"edit.php?mod=delaffil\">$lang_users_yes</a> &nbsp;&nbsp;&nbsp;&nbsp; <a href=\"index.php\">$lang_users_no</a>");
        $val = newsdbtbl("0",$first_tcolor,$sec_tcolor,$contenu,$border,$lang_Users,$titre_color);
        $val = center($val);
        $val = saut(2)."$val";
        print "$val\n";
}
else
{
     print  errormsg("$lang_badparams_submit");
     slislog(error,"Bad params submit to users/view.php by $REMOTE_ADDR in $mode with id $id from $HTTP_REFERER");
}



//fin de page
print $end;

//close sql
pg_close($db);
?>
